<?php
// ********************************************************************************************
// Title          udde Picture Frame Information System (uddePF)
// Description    Picture Frame Information System for Joomla 1.5 and Joomla 1.6
// Author          2011 Stephan Slabihoud
// License        This is free software and you may redistribute it under the GPL.
//                uddePF comes with absolutely no warranty.
//                Use at your own risk. For details, see the license at
//                http://www.gnu.org/licenses/gpl.txt
//                Other licenses can be found in LICENSES folder.
//                Redistributing this file is only allowed when keeping the header unchanged.
// ********************************************************************************************

if (!(defined('_JEXEC') || defined('_VALID_MOS'))) { die( 'Direct Access to this location is not allowed.' ); }

$versionstring	= "uddePF 1.3/stable";

$ver = new JVersion();
if (!strncasecmp($ver->RELEASE, "2.5", 3)) {
	require_once(JPATH_SITE.'/administrator/components/com_uddepf/uddepflib25.php');
} else if (!strncasecmp($ver->RELEASE, "1.7", 3)) {
	require_once(JPATH_SITE.'/administrator/components/com_uddepf/uddepflib17.php');
} else if (!strncasecmp($ver->RELEASE, "1.6", 3)) {
	require_once(JPATH_SITE.'/administrator/components/com_uddepf/uddepflib16.php');
} else {
	require_once(JPATH_SITE.'/administrator/components/com_uddepf/uddepflib15.php');
}

$pathtoadmin = uddePF::uddePFgetPath('admin');
require_once($pathtoadmin.'/library/tools.php');
require_once($pathtoadmin.'/library/pfplugin.php');
require_once($pathtoadmin.'/library/imagettftextboxopt.php');

$config = uddePFloadSettings();
uddePFtools::loadLanguage( "", $config->config_language);

$userid = uddePF::uddePFgetUserID();
$my_gid = uddePF::uddePFgetGID($userid);
if (!uddePF::uddePFisAdmin($my_gid)) {
	$mosmsg = _UDDEPFADM_VIOLATION;
	$app = & JFactory::getApplication();
	$app->redirect(JRoute::_("index.php"), $mosmsg);
}

// ******************************************************************************************************

// Read all plugins
$plugindir = glob( $pathtoadmin. '/plugins/'.'*.php' );
$plugins = Array();
$i = 0;
foreach( $plugindir as $key=>$value ) {
	$path_parts = pathinfo($value);
	$plugins[$i]["filename"] = $path_parts['filename'];
	$plugins[$i]["file"] = $value;

	require_once $plugins[$i]["file"];
	$plugins[$i]["plugin"] = new $plugins[$i]["filename"]( uddePF::getConnection(), uddePF::uddePFgetDBprefix() );
	uddePFtools::loadLanguage( $plugins[$i]["filename"], $config->config_language );
	$i++;
}

// Reorder the plugins, so we draw everything in the correct order
// Is there already an ordering?
$temp = explode( ",", $config->config_plugins_ordering );
// Rebuild the plugins array with the found ording, orphaned plugins will be ignored
$ps = Array();
$i = 0;
foreach($temp as $key=>$pluginname) {
	foreach($plugins as $k=>$v) {
		if ($pluginname==$v["filename"]) {
			$ps[$i]["filename"] = $v["filename"];
			$ps[$i]["file"] 	= $v["file"];
			$ps[$i]["plugin"] 	= $v["plugin"];
			$i++;
		}
	}
}
// Check if there are new plugins and add them to the array
foreach($plugins as $plugin=>$value) {
	$found = false;
	foreach($ps as $k=>$v) {
		if ($value["filename"]==$v["filename"]) {
			$found = true;
			break;
		}
	}
	if (!$found) {
		$ps[$i]["filename"] = $value["filename"];
		$ps[$i]["file"] 	= $value["file"];
		$ps[$i]["plugin"] 	= $value["plugin"];
		$i++;
	}
}
$plugins = $ps;
// "ps" contains all plugins in the correct order

// ******************************************************************************************************

switch ($task) {

	case "preview":
		uddePFupdate($option, $task, $plugins, $config, false);
		break;

	case "update":
		uddePFupdate($option, $task, $plugins, $config, true);
		break;

	case "settings":
		uddePFshowSettings($option, $task, $plugins, $config, $versionstring);
		break;

	case "savesettings":
		foreach( $plugins as $key=>$plugin ) {
			$plugin["plugin"]->getConfiguration();
			$plugin["plugin"]->saveConfiguration();
		}
		uddePFgetSettings($config);
		uddePFsaveSettings($config);
		break;
	
	case "cancel":
		$app = & JFactory::getApplication();
		$app->redirect(JRoute::_("index.php"));

	default:
		uddePFshowSettings($option, $task, $plugins, $config, $versionstring);
		break;	
}

function uddePFupdate($option, $task, $plugins, $config, $forceUpdate) {
	// $forceUpdate = true;
	require_once ( dirname(__FILE__).'/script/update.php' );
	$mosmsg=_UDDEPFADM_UPDATED;

	$app = & JFactory::getApplication();
	$app->redirect(JRoute::_("index.php?option=com_uddepf&task=settings"), $mosmsg);
}

function uddePFshowSettings($option, $task, $plugins, $config, $versionstring) {
	
?>
  <form action="index.php" method="POST" name="adminForm" id="adminForm">

  <div align="center">
  <table cellpadding="4" cellspacing="0" border="0" width="98%">
  <tr>
    <td class="sectionname" align="left" valign="top" width="25%">
		<img align="middle" style="display: inline; border:1px solid lightgray;" src="<?php echo uddePF::uddePFgetPath('live_site')."/administrator/components/com_uddepf/resources/icons/uddepf_logo.png"; ?>" width="150" height="75" />
    </td>
<?php
//    <td align="center" valign="top" width="25%">
//		< ? php echo "<h4>"._UDDEPFADM_SETTINGS."</h4>"; ? >
//    </td>
?>
    <td align="right" valign="top" width="75%">
		<?php
			$previewimage = dirname(__FILE__).'/pictureframe/'.'pf'.$config->config_cryptedlink.'.jpg';
			if (file_exists($previewimage) && is_file($previewimage)) {
				echo "<a href='". uddePF::uddePFgetPath('live_site')."/administrator/components/com_uddepf/pictureframe/pf".$config->config_cryptedlink.".jpg' target='_new'>";
				echo "<img src='".uddePF::uddePFgetPath('live_site')."/administrator/components/com_uddepf/pictureframe/pf".$config->config_cryptedlink.".jpg' height='150' />";
				echo "</a>";
			} else {
				echo "<img src='".uddePF::uddePFgetPath('live_site')."/administrator/components/com_uddepf/resources/images/updatepreview.jpg' height='150' />";
			}
			if ($config->config_enable2nd) {
				$ext = "2";
				$previewimage = dirname(__FILE__).'/pictureframe/'.'pf'.$config->config_cryptedlink.$ext.'.jpg';
				if (file_exists($previewimage) && is_file($previewimage)) {
					echo "&nbsp;<a href='". uddePF::uddePFgetPath('live_site')."/administrator/components/com_uddepf/pictureframe/pf".$config->config_cryptedlink.$ext.".jpg' target='_new'>";
					echo "<img src='".uddePF::uddePFgetPath('live_site')."/administrator/components/com_uddepf/pictureframe/pf".$config->config_cryptedlink.$ext.".jpg' height='150' />";
					echo "</a>";
				} else {
					echo "&nbsp;<img src='".uddePF::uddePFgetPath('live_site')."/administrator/components/com_uddepf/resources/images/updatepreview.jpg' height='150' />";
				}
			}
			echo "<br />"._UDDEPFADM_PAGE;
			$current_page = uddePFtools::loadValue(uddePF::getConnection(), uddePF::uddePFgetDBprefix(), "current_page", 0);
			echo $current_page;
		?>
    </td>
  </tr>
  </table>
  </div>

<?php	

	// ==================================================================================================================

	jimport('joomla.html.pane');
	$tabs = & JPane::getInstance('tabs', array('startOffset'=>0, 'useCookies'=>true)); 
	echo $tabs->startPane( 'pane' );
	echo $tabs->startPanel( _UDDEPFADM_INFO, 'info-tab' );
?>
		<table width="100%" border="0" cellpadding="4" cellspacing="2" class="adminForm" id="adminForm">
			<?php
				echo "<tr><td colspan='3' align='left'>";

				echo "<table border='0' cellpdding='0' cellspacing='2'>";
				echo "<tr><th align='left' colspan='2'><p>"._UDDEPFADM_CONFIG_HL."</p></th></tr>";

				echo "<tr><th align='left' colspan='2'><p>"._UDDEPFADM_1STFRAME."</p></th></tr>";
				echo "<tr><th align='left'>"._UDDEPFADM_INFO_URL."</th><td align='left'>".uddePF::uddePFgetPath('live_site')."/administrator/components/com_uddepf/pictureframe/pf".$config->config_cryptedlink.".jpg"."</td></tr>";
				echo "<tr><th align='left'>"._UDDEPFADM_INFO_RSS."</th><td align='left'>".uddePF::uddePFgetPath('live_site')."/administrator/components/com_uddepf/pictureframe/pf".$config->config_cryptedlink.".xml"."</td></tr>";

				if ($config->config_enable2nd) {
					$ext = "2";
					echo "<tr><th align='left' colspan='2'><p>"._UDDEPFADM_2NDFRAME."</p></th></tr>";
					echo "<tr><th align='left'>"._UDDEPFADM_INFO_URL."</th><td align='left'>".uddePF::uddePFgetPath('live_site')."/administrator/components/com_uddepf/pictureframe/pf".$config->config_cryptedlink.$ext.".jpg"."</td></tr>";
					echo "<tr><th align='left'>"._UDDEPFADM_INFO_RSS."</th><td align='left'>".uddePF::uddePFgetPath('live_site')."/administrator/components/com_uddepf/pictureframe/pf".$config->config_cryptedlink.$ext.".xml"."</td></tr>";
				}

				echo "<tr><th align='left' colspan='2'><p>"._UDDEPFADM_CONFIG_SRV."</p></th></tr>";
				echo "<tr><th align='left'>"._UDDEPFADM_INFO_SCRIPT."</th><td align='left'>".uddePF::uddePFgetPath('live_site')."/administrator/components/com_uddepf/script/update.php"."</td></tr>";
				echo "<tr><th align='left'>&nbsp;</th><td align='left'>".uddePF::uddePFgetPath('admin')."/script/update.php"."</td></tr>";
				echo "<tr><th align='left'>&nbsp;</th><td align='left'>".uddePF::uddePFgetPath('live_site')."/administrator/components/com_uddepf/script/siteupdate.php"." (GIF)</td></tr>";
				if ($config->config_main_password)
					echo "<tr><th align='left'></th><td align='left'>"._UDDEPFADM_INFO_PASSWORD."</td></tr>";
				else
					echo "<tr><th align='left'></th><td align='left'>"._UDDEPFADM_INFO_NOPASSWORD."</td></tr>";
				echo "</table>";

				echo "</td></tr>";
			?>

		</table>
<?php
	echo $tabs->endPanel();

	// ==================================================================================================================

	echo $tabs->startPanel( _UDDEPFADM_CONFIG, 'info-tab' );
?>
		<table width="100%" border="0" cellpadding="4" cellspacing="2" class="adminForm" id="adminForm">
			<?php
				uddePF::admText($config->config_main_username, 20, 'config_main_username', _UDDEPFADM_MAINUSERNAME_HEAD, _UDDEPFADM_MAINUSERNAME_EXP);
				uddePF::admText($config->config_main_password, 20, 'config_main_password', _UDDEPFADM_MAINPASSWORD_HEAD, _UDDEPFADM_MAINPASSWORD_EXP);
				uddePF::admText($config->config_cryptedlink, 40, 'config_cryptedlink', _UDDEPFADM_CRYPTEDLINK_HEAD, _UDDEPFADM_CRYPTEDLINK_EXP );
				$localpath = dirname(__FILE__).'/language/'.'*.php';
				$thedir = glob( $localpath );
				$arr = Array();
				$i = 0;
				foreach( $thedir as $key=>$value ) {
					$path_parts = pathinfo($value);
					$arr[ $path_parts['filename'] ] = $path_parts['filename'];
				}
				uddePF::admSelect($config->config_language, 'config_language', $arr, _UDDEPFADM_LANGUAGE_HEAD, _UDDEPFADM_LANGUAGE_EXP, true);
				$arr = Array();
				$arr[  'default' ]						= _UDDEPFADM_SELECT_DEFAULT;
				$arr[  'de_DE.UTF8,de_DE,de,ge,deu' ]	= _UDDEPFADM_SELECT_GERMAN;
				$arr[  'en_US.UTF8,en_US,en,eng' ]		= _UDDEPFADM_SELECT_ENGLISH;
				$arr[  'nl_NL.UTF8,nl_NL,nl,nld' ]		= _UDDEPFADM_SELECT_DUTCH;
				$arr[  'fr_FR.UTF8,fr_FR,fr,fra' ]		= _UDDEPFADM_SELECT_FRENCH;
				$arr[  'fi_FI.UTF8,fi_FI,fi,fin' ]		= _UDDEPFADM_SELECT_FINNISH;
				$arr[  'cn_CN.UTF8,cn_CN,cn,chinese' ]	= _UDDEPFADM_SELECT_CHINESE;
				uddePF::admSelect($config->config_locale, 'config_locale', $arr, _UDDEPFADM_LOCALE_HEAD, _UDDEPFADM_LOCALE_EXP);

				// -------------------------------------------------
				
				$arr = Array();
				$arr[  '1' ]	= _UDDEPFADM_SELECT_1PAGE;
				$arr[  '2' ]	= _UDDEPFADM_SELECT_2PAGES;
				$arr[  '3' ]	= _UDDEPFADM_SELECT_3PAGES;
				$arr[  '4' ]	= _UDDEPFADM_SELECT_4PAGES;
				$arr[  '5' ]	= _UDDEPFADM_SELECT_5PAGES;
				$arr[  '6' ]	= _UDDEPFADM_SELECT_6PAGES;
				uddePF::admSelect($config->config_maxpages, 'config_maxpages', $arr, _UDDEPFADM_MAXPAGES_HEAD, _UDDEPFADM_MAXPAGES_EXP, true);

				// -------------------------------------------------
				
				echo '<tr><td colspan="3"><hr></td></tr>';
				echo '<tr><td colspan="3"><b>'._UDDEPFADM_1STFRAME.'</b></td></tr>';
				$arr = Array();
				$arr[  '640' ]	= '640';
				$arr[  '720' ]	= '720';
				$arr[  '768' ]	= '768';
				$arr[  '800' ]	= '800';
				$arr[  '840' ]	= '840';
				$arr[ '1024' ]	= '1024';
				$arr[ '1280' ]	= '1280';
				$arr[ '1366' ]	= '1366';
				uddePF::admSelect($config->config_picture_width, 'config_picture_width', $arr, _UDDEPFADM_PICWIDTH_HEAD, _UDDEPFADM_PICWIDTH_EXP);
				$arr = Array();
				$arr[  '480' ]	= '480';
				$arr[  '504' ]	= '504';
				$arr[  '600' ]	= '600';
				$arr[  '768' ]	= '768';
				$arr[ '1024' ]	= '1024';
				uddePF::admSelect($config->config_picture_height, 'config_picture_height', $arr, _UDDEPFADM_PICHEIGHT_HEAD, _UDDEPFADM_PICHEIGHT_EXP);
				uddePF::admText($config->config_col0, 10, 'config_col0', _UDDEPFADM_CONFCOL0_HEAD, _UDDEPFADM_CONFCOL0_EXP );
				uddePF::admText($config->config_col1, 10, 'config_col1', _UDDEPFADM_CONFCOL1_HEAD, _UDDEPFADM_CONFCOL1_EXP );
				uddePF::admText($config->config_col2, 10, 'config_col2', _UDDEPFADM_CONFCOL2_HEAD, _UDDEPFADM_CONFCOL2_EXP );

				// -------------------------------------------------
				
				echo '<tr><td colspan="3"><hr></td></tr>';
				echo '<tr><td colspan="3"><b>'._UDDEPFADM_2NDFRAME.'</b></td></tr>';
				uddePF::admYesNo($config->config_enable2nd, 'config_enable2nd', _UDDEPFADM_2NDFRAME_HEAD, _UDDEPFADM_2NDFRAME_EXP);
				$arr = Array();
				$arr[  '640' ]	= '640';
				$arr[  '720' ]	= '720';
				$arr[  '768' ]	= '768';
				$arr[  '800' ]	= '800';
				$arr[  '840' ]	= '840';
				$arr[ '1024' ]	= '1024';
				$arr[ '1280' ]	= '1280';
				$arr[ '1366' ]	= '1366';
				uddePF::admSelect($config->config_picture_width_1, 'config_picture_width_1', $arr, _UDDEPFADM_PICWIDTH_HEAD, _UDDEPFADM_PICWIDTH_EXP);
				$arr = Array();
				$arr[  '480' ]	= '480';
				$arr[  '504' ]	= '504';
				$arr[  '600' ]	= '600';
				$arr[  '768' ]	= '768';
				$arr[ '1024' ]	= '1024';
				uddePF::admSelect($config->config_picture_height_1, 'config_picture_height_1', $arr, _UDDEPFADM_PICHEIGHT_HEAD, _UDDEPFADM_PICHEIGHT_EXP);
				uddePF::admText($config->config_col0_1, 10, 'config_col0_1', _UDDEPFADM_CONFCOL0_HEAD, _UDDEPFADM_CONFCOL0_EXP );
				uddePF::admText($config->config_col1_1, 10, 'config_col1_1', _UDDEPFADM_CONFCOL1_HEAD, _UDDEPFADM_CONFCOL1_EXP );
				uddePF::admText($config->config_col2_1, 10, 'config_col2_1', _UDDEPFADM_CONFCOL2_HEAD, _UDDEPFADM_CONFCOL2_EXP );

				// -------------------------------------------------
				
				$localpath = dirname(__FILE__).'/resources'.'/fonts'.'/'.'*.ttf';
				$thedir = glob( $localpath );
				$arr = Array();
				$i = 0;
				foreach( $thedir as $key=>$value ) {
					$path_parts = pathinfo($value);
					$arr[ $path_parts['filename'] ] = $path_parts['filename'];
				}
				uddePF::admSelect($config->config_font, 'config_font', $arr, _UDDEPFADM_FONT_HEAD, _UDDEPFADM_FONT_EXP, true);
				uddePF::admSelect($config->config_fontb, 'config_fontb', $arr, _UDDEPFADM_FONTB_HEAD, _UDDEPFADM_FONTB_EXP);
				$arr = Array();
				$arr[  '25' ]	= _UDDEPFADM_SELECT_Q25;
				$arr[  '50' ]	= _UDDEPFADM_SELECT_Q50;
				$arr[  '75' ]	= _UDDEPFADM_SELECT_Q75;
				$arr[  '85' ]	= _UDDEPFADM_SELECT_Q85;
				$arr[  '100' ]	= _UDDEPFADM_SELECT_Q100;
				uddePF::admSelect($config->config_quality, 'config_quality', $arr, _UDDEPFADM_QUALITY_HEAD, _UDDEPFADM_QUALITY_EXP);
				
				// -------------------------------------------------
				
				$document = &JFactory::getDocument();
				$document->addScript( uddePF::uddePFgetPath('live_site').'/administrator/components/com_uddepf/resources/js/tools.js' );
				echo '<tr><td colspan="3"><hr></td></tr>';
				echo '<tr>';
				echo '<td align="left" valign="top"><strong>'._UDDEPFADM_ORDERING_HEAD.'</strong></td>';
				echo '<td align="left" valign="top">';
				$temp = Array();
echo "<table border='0'><tr><td align='left' valign='top'>";
				echo "<select size='".count($plugins)."' name='allPlugins' id='allPlugins'>";
				foreach( $plugins as $key=>$plugin ) {
					echo "<option value='".uddePF::_clean($plugin["filename"])."'>".uddePF::_clean($plugin["plugin"]->getPluginName())."</option>";
					$temp[] = $plugin["filename"];
				}
				$tempj = implode(",", $temp);
				echo "</select>";
echo "</td><td align='left' valign='middle'>";
				echo "<input type='button' name='buttonup' class='button' value='"._UDDEPFADM_SELECT_UP."' onclick='uddePFmove( \"adminForm\", \"allPlugins\", \"allPluginsIDs\", -1 );' /><br />";
				echo "<input type='button' name='buttondn' class='button' value='"._UDDEPFADM_SELECT_DOWN."' onclick='uddePFmove( \"adminForm\", \"allPlugins\", \"allPluginsIDs\", 1 );' />";
				echo "<input type='hidden' name='allPluginsIDs' size='40' value='".uddePF::_clean($tempj)."' />";
echo "</td></tr></table>";
				echo '</td>';
				echo '<td align="left" valign="top" width="50%">'._UDDEPFADM_ORDERING_EXP.'</td>';
				echo '</tr>';

				// -------------------------------------------------
				
				uddePF::admYesNo($config->config_debug, 'config_debug', _UDDEPFADM_DEBUG_HEAD, _UDDEPFADM_DEBUG_EXP, true);
			?>

		</table>
<?php
	echo $tabs->endPanel();

	// ==================================================================================================================

	foreach( $plugins as $key=>$plugin ) {
		echo $tabs->startPanel( $plugin["plugin"]->getPluginName(), "plugin-".$key."-tab" );
		?>
			<table width="100%" border="0" cellpadding="4" cellspacing="2" class="adminForm" id="adminForm">
				<?php
					$plugin["plugin"]->showConfiguration();
				?>
			</table>
		<?php
		echo $tabs->endPanel();
	}
	
	// ==================================================================================================================

	echo $tabs->startPanel( _UDDEPFADM_ABOUT, 'about-tab' );
?>
		<table width="100%" border="0" cellpadding="4" cellspacing="2" class="adminForm" id="adminForm">
			<tr align="center" valign="middle">
				<td colspan="3" align="left" valign="top">
					<h2>uddePF</h2>
					<?php echo "<p><span style='color: red;'>".$versionstring."</span></p>\n"; ?>

					<p><b>uddePF (Picture Frame)</b><br />
					Picture Frame component for Joomla 1.5 and Joomla 1.6<br />
					&copy; 2011 Stephan Slabihoud</p>

					<?php echo "<p>"._UDDEPFADM_TRANSLATORS_CREDITS."</p>"; ?>

					<?php
						echo "<p><table border='0' cellspacing='0' celpadding='0'>";
						echo "<tr><th>"._UDDEPFADM_PLUGIN."</th><th>"._UDDEPFADM_VERSION."</th></tr>";
						foreach( $plugins as $key=>$plugin ) {
							$name = $plugin["plugin"]->getPluginName();
							$ver = $plugin["plugin"]->getPluginVersion();
							echo "<tr><td>".$name."&nbsp;</td><td>&nbsp;".$ver."</td></tr>";
						}
						echo "</table></p>";
					?>

					<p><b>Thanks in advance...</b><br />
					You can use and distribute uddePF freely, but if you really find it useful, a small donation would be 
					very appreciated. uddePF is the result of hard work, spending hours developing and testing this component.
					If you feel that you would like to give a donation for your use of uddePF, or just because you want to 
					support uddePF for future updates, please make a small donation using the PayPal buttons below.</p>
					
					<p>uddePF comes with absolutely no warranty.<br />
					For details, see the license at <a href="http://www.gnu.org/licenses/gpl.txt">www.gnu.org/licenses/gpl.txt</a>.</p>
				</td>
			</tr>
		</table>
<?php	
	echo $tabs->endPanel();

	// ==================================================================================================================

	echo $tabs->endPane();
?>
	<input type="hidden" name="option" value="<?php echo $option; ?>" />
	<input type="hidden" name="task" value="<?php echo $task;?>" />
	<input type="hidden" name="boxchecked" value="0" />
	<input type="hidden" name="hidemainmenu" value="0" />
</form>
	<br clear="all">

<p><?php echo _UDDEPFADM_DONATE; ?><br />

<table border="0" cellpadding="2" cellspacing="2"><tr><td>
<form action="https://www.paypal.com/cgi-bin/webscr" method="post" />
<input type="hidden" name="cmd" value="_xclick" />
<input type="hidden" name="business" value="paypal@slabihoud.de" />
<input type="hidden" name="page_style" value="uddePF" />
<input type="hidden" name="item_name" value="Untersttzung uddePF Entwicklung" />
<input type="hidden" name="charset" value="ISO-8859-1" />
<input type="hidden" name="item_number" value="2110002" />
<input type="hidden" name="no_shipping" value="1" />
<input type="hidden" name="no_note" value="1" />
<input type="hidden" name="cn" value="">
<input type="hidden" name="currency_code" value="EUR" />
<input type="hidden" name="tax" value="0" />
<input type="hidden" name="lc" value="DE" />
<input type="hidden" name="bn" value="PP-DonationsBF:donate_d.gif:NonHosted" />
<input type="image" src="<?php echo uddePF::uddePFgetPath('live_site')."/administrator/components/com_uddepf/resources/icons/donate_d.gif"; ?>" border="0" name="submit" alt="PayPal Spenden" />
</form>
</td><td>
<form action="https://www.paypal.com/cgi-bin/webscr" method="post" />
<input type="hidden" name="cmd" value="_xclick" />
<input type="hidden" name="business" value="paypal@slabihoud.de" />
<input type="hidden" name="page_style" value="uddePF" />
<input type="hidden" name="item_name" value="Donation uddePF development" />
<input type="hidden" name="item_number" value="2110002" />
<input type="hidden" name="no_shipping" value="1" />
<input type="hidden" name="no_note" value="1" />
<input type="hidden" name="cn" value="">
<input type="hidden" name="currency_code" value="USD" />
<input type="hidden" name="tax" value="0" />
<input type="hidden" name="lc" value="US" />
<input type="hidden" name="bn" value="PP-DonationsBF:donate_en.gif:NonHosted" />
<input type="image" src="<?php echo uddePF::uddePFgetPath('live_site')."/administrator/components/com_uddepf/resources/icons/donate_en.gif"; ?>" border="0" name="submit" alt="PayPal Donations" />
</form>
</td></tr></table>
</p>

<?php	
}

function uddePFgetSettings(&$config) {
	$config->config_cryptedlink			= uddePF::getParameter( 'config_cryptedlink', "", 'post', 'string' );
	$config->config_maxpages			= (int)uddePF::getParameter( 'config_maxpages', "", 'post', 'int' );
	$config->config_picture_width		= (int)uddePF::getParameter( 'config_picture_width', "", 'post', 'int' );
	$config->config_picture_height		= (int)uddePF::getParameter( 'config_picture_height', "", 'post', 'int' );
	$config->config_col0				= (int)uddePF::getParameter( 'config_col0', 20, 'post', 'int' );
	$config->config_col1				= (int)uddePF::getParameter( 'config_col1', 320, 'post', 'int' );
	$config->config_col2				= (int)uddePF::getParameter( 'config_col2', 420, 'post', 'int' );
	$config->config_enable2nd			= (int)uddePF::getParameter( 'config_enable2nd', 0, 'post', 'int' );
	$config->config_picture_width_1		= (int)uddePF::getParameter( 'config_picture_width_1', "", 'post', 'int' );
	$config->config_picture_height_1	= (int)uddePF::getParameter( 'config_picture_height_1', "", 'post', 'int' );
	$config->config_col0_1				= (int)uddePF::getParameter( 'config_col0_1', 20, 'post', 'int' );
	$config->config_col1_1				= (int)uddePF::getParameter( 'config_col1_1', 320, 'post', 'int' );
	$config->config_col2_1				= (int)uddePF::getParameter( 'config_col2_1', 420, 'post', 'int' );
	$config->config_plugins_ordering	= uddePF::getParameter( 'allPluginsIDs', "", 'post', 'string' );
	$config->config_main_username		= uddePF::getParameter( 'config_main_username', "", 'post', 'string' );
	$config->config_main_password		= uddePF::getParameter( 'config_main_password', "", 'post', 'string' );
	$config->config_language			= uddePF::getParameter( 'config_language', "", 'post', 'string' );
	$config->config_font				= uddePF::getParameter( 'config_font', "", 'post', 'string' );
	$config->config_fontb				= uddePF::getParameter( 'config_fontb', "", 'post', 'string' );
	$config->config_locale				= uddePF::getParameter( 'config_locale', "", 'post', 'string' );
	$config->config_quality				= (int)uddePF::getParameter( 'config_quality', 75, 'post', 'int' );
	$config->config_debug				= (int)uddePF::getParameter( 'config_debug', 0, 'post', 'int' );
}

function uddePFloadSettings() {
	$database =& JFactory::getDBO();
	$config = new uddePFconfig();
	$query = "SELECT varname, value FROM #__uddepf_config WHERE plugin = 'PFSystem'";
	$database->setQuery($query);
	$results = $database->loadObjectList();
	if (!$database->query()) echo("SQL error: ".$database->stderr(true));
	foreach ($results as $result) {
		if (substr($result->varname,0,1)!='_')
			$config->{$result->varname} = stripslashes($result->value);
	}
//	$config = new uddePFconfig();
//	$query = "SELECT varname, value FROM ".uddePF::uddePFgetDBprefix()."uddepf_config"." WHERE plugin = 'PFSystem'";
//	$result = mysql_query($query, uddePF::getConnection()) or die('Error: '.mysql_error());
//    while ($row = mysql_fetch_object( $result )) {
//		if (substr($row->varname,0,1)!='_')
//			$config->{$row->varname} = stripslashes($row->value);		// unescape strings
//    }
	return $config;
}

function uddePFsaveSettings($config) {
	$database =& JFactory::getDBO();
	$data = Array();
	$data["config_cryptedlink"]			= $config->config_cryptedlink;
	$data["config_maxpages"]			= $config->config_maxpages;
	$data["config_picture_width"]		= $config->config_picture_width;
	$data["config_picture_height"]		= $config->config_picture_height;
	$data["config_col0"]				= $config->config_col0;
	$data["config_col1"]				= $config->config_col1;
	$data["config_col2"]				= $config->config_col2;
	$data["config_enable2nd"]			= $config->config_enable2nd;
	$data["config_picture_width_1"]		= $config->config_picture_width_1;
	$data["config_picture_height_1"]	= $config->config_picture_height_1;
	$data["config_col0_1"]				= $config->config_col0_1;
	$data["config_col1_1"]				= $config->config_col1_1;
	$data["config_col2_1"]				= $config->config_col2_1;
	$data["config_plugins_ordering"]	= $config->config_plugins_ordering;
	$data["config_main_username"]		= $config->config_main_username;
	$data["config_main_password"]		= $config->config_main_password;
	$data["config_language"]			= $config->config_language;
	$data["config_font"]				= $config->config_font;
	$data["config_fontb"]				= $config->config_fontb;
	$data["config_locale"]				= $config->config_locale;
	$data["config_quality"]				= $config->config_quality;
	$data["config_debug"]				= $config->config_debug;

//	$query  = "DELETE FROM ".uddePF::uddePFgetDBprefix()."uddepf_config"." WHERE plugin = 'PFSystem'";
//	mysql_query($query, uddePF::getConnection()) or die('Error: '.mysql_error());
//	foreach($data as $key=>$value) {
//		$query = "INSERT INTO ".uddePF::uddePFgetDBprefix()."uddepf_config"." ( plugin, varname, value ) 
//					VALUES ( 'PFSystem', '". mysql_real_escape_string($key) ."', '".  mysql_real_escape_string($value) ."' )";
//		mysql_query($query, uddePF::getConnection()) or die('Error: '.mysql_error());
//	}

	$query  = "DELETE FROM #__uddepf_config WHERE plugin = 'PFSystem'";
	$database->setQuery($query);
	if (!$database->query()) echo("SQL error: ".$database->stderr(true));

	foreach ($data as $key => $value) {
		$query = 'INSERT INTO #__uddepf_config ( plugin, varname, value ) 
					VALUES ( "PFSystem", '.$database->Quote($key).', '.$database->Quote($value).' )';
		$database->setQuery($query);
		if (!$database->query()) echo("SQL error: ".$database->stderr(true));
	}

	// Enable Basic authentication for script folder
	$htaccess = dirname(__FILE__).'/script/.htaccess';
	$htpasswd = dirname(__FILE__).'/script/.htpasswd';

	if ($config->config_main_password) {
		$fout = fopen($htaccess, 'w');
		fputs($fout, "#.htaccess\n" .
					"AuthUserFile ".$htpasswd."\n".
					"AuthName \"Picture Frame\"\n".
					"AuthType Basic\n".
					"require valid-user\n");
		fclose($fout);

		$fout = fopen($htpasswd, 'w');
		fputs($fout, $config->config_main_username.':'.crypt($config->config_main_password)."\n");
		fclose($fout);
	} else {
		$fout = fopen($htaccess, 'w');
		fputs($fout, '#.htaccess\n' .
					'allow from all\n');
		fclose($fout);

		$fout = fopen($htpasswd, 'w');
		fputs($fout, '#empty file\n');
		fclose($fout);
	}

	$mosmsg=_UDDEPFADM_SETTINGSSAVED;
	$app = & JFactory::getApplication();
	$app->redirect(JRoute::_("index.php?option=com_uddepf&task=settings"), $mosmsg);
}

