<?php
// ********************************************************************************************
// Title          udde Picture Frame Information System (uddePF)
// Description    Picture Frame Information System for Joomla 1.5 and Joomla 1.6
// Author          2011 Stephan Slabihoud
// License        This is free software and you may redistribute it under the GPL.
//                uddePF comes with absolutely no warranty.
//                Use at your own risk. For details, see the license at
//                http://www.gnu.org/licenses/gpl.txt
//                Other licenses can be found in LICENSES folder.
//                Redistributing this file is only allowed when keeping the header unchanged.
// ********************************************************************************************

DEFINE('UDDEPF_MODE_ENABLE', 		0x01);
DEFINE('UDDEPF_MODE_UPDATE', 		0x02);
DEFINE('UDDEPF_MODE_PAGES', 		0x04);
DEFINE('UDDEPF_MODE_COL1',	 		0x08);
DEFINE('UDDEPF_MODE_COL2',	 		0x10);
DEFINE('UDDEPF_MODE_COL3',	 		0x20);

class uddePFconfig {
	var $config_cryptedlink = "";
	var $config_picture_width = 800;
	var $config_picture_height = 600;
	var $config_col0 = 20;
	var $config_col1 = 320;
	var $config_col2 = 420;
	var $config_enable2nd = 0;
	var $config_picture_width_1 = 800;
	var $config_picture_height_1 = 480;
	var $config_col0_1 = 20;
	var $config_col1_1 = 320;
	var $config_col2_1 = 420;
	var $config_plugins_ordering = "";
	var $config_main_username = "";
	var $config_main_password = "";
	var $config_language = "english";
	var $config_maxpages = 0;
	var $config_font = "LiberationSansNarrow-Regular";
	var $config_fontb = "LiberationSansNarrow-Bold";
	var $config_locale = "de_DE.UTF8,de_DE,de,ge";
	var $config_quality = 75;
	var $config_debug = 0;
}

interface IFPlugin
{
	public function __construct($dbconn, $tableprefix);
	public function getPluginName();
	public function getPluginVersion();
	public function isOnThisPage($current_page=0);
	public function isOnThisPage2($current_page=0);
	public function showConfiguration();
	public function getConfiguration();
	public function loadConfiguration();
	public function saveConfiguration();
	public function doUpdate($forceUpdate);
	public function doPreflight(&$image, $style, $forceUpdate, &$yoffset);
	public function doOutput(&$image, $style, $forceUpdate, &$yoffset);
	public function doPostflight(&$image, $style, $forceUpdate, &$yoffset);
}

class PFPlugin implements IFPlugin
{
	protected $config_enable = 0;
	protected $config_updateperiod = 0;
	protected $config_page = "";			// page the plugin is responsible for
	protected $config_col = 0;				// display in column (0=default, 1=left, 2=middle, 3=right)
	protected $config_page_1 = "";			// page the plugin is responsible for
	protected $config_col_1 = 0;			// display in column (0=default, 1=left, 2=middle, 3=right)

    protected $dbconn = NULL;				// database connection resource
	protected $tableconfig = NULL;			// storing the configuration
	protected $tablestore = NULL;			// storing update data
	protected $plugin = NULL;				// class name, e.g. "PFWeatherPlugin"

	public function __construct($dbconn, $tableprefix) {
		$this->dbconn = $dbconn;
		$this->tableconfig = $tableprefix."uddepf_config";
		$this->tablestore = $tableprefix."uddepf_".get_class($this);
		$this->plugin = get_class($this);;
		$this->loadConfiguration();
	}

	public function loadConfiguration() {
		$query = "SELECT varname, value FROM ".$this->tableconfig." WHERE plugin = '".$this->plugin."'";
		$result = mysql_query($query, $this->dbconn) or die('Error: '.mysql_error());
        while ($row = mysql_fetch_object( $result )) {
			if (substr($row->varname,0,1)!='_')
				$this->{$row->varname} = stripslashes($row->value);		// unescape strings
        }
	}

	public function getPluginName() {
		return "NN";
	}

	public function getPluginVersion() {
		return "0.0";
	}

	public function isOnThisPage($current_page=0) {
		$isPage = explode(",", $this->config_page);
		if (in_array($current_page, $isPage))
			return 1;
		if ($current_page==0)
			return 1;
		return 0;
	}

	public function isOnThisPage2($current_page=0) {
		$isPage = explode(",", $this->config_page_1);
		if (in_array($current_page, $isPage))
			return 1;
		if ($current_page==0)
			return 1;
		return 0;
	}

	public function showConfiguration() {}
	public function getConfiguration() {}
	public function saveConfiguration() {}
	
	public function doUpdate($forceUpdate) {}
	public function doPreflight(&$image, $style, $forceUpdate, &$yoffset) {}
	public function doOutput(&$image, $style, $forceUpdate, &$yoffset) {}
	public function doPostflight(&$image, $style, $forceUpdate, &$yoffset) {}

	protected function showConfigurationHelper($mode=0) {
		if ($mode & UDDEPF_MODE_ENABLE) {
			uddePF::admYesNo($this->config_enable, 'config_'.$this->plugin.'_enable', _UDDEPFADM_ENABLE_HEAD, _UDDEPFADM_ENABLE_EXP);
		}
		if ($mode & UDDEPF_MODE_UPDATE) {
			$arr = Array();
			$arr[ '0' ] 		= _UDDEPFADM_SELECT_IMMEDIATELY;
			$arr[ '5' ] 		= _UDDEPFADM_SELECT_5MIN;
			$arr[ '10' ] 		= _UDDEPFADM_SELECT_10MIN;
			$arr[ '15' ] 		= _UDDEPFADM_SELECT_15MIN;
			$arr[ '20' ] 		= _UDDEPFADM_SELECT_20MIN;
			$arr[ '30' ] 		= _UDDEPFADM_SELECT_30MIN;
			$arr[ '60' ] 		= _UDDEPFADM_SELECT_1HOUR;
			$arr[ '120' ] 		= _UDDEPFADM_SELECT_2HOURS;
			$arr[ '180' ] 		= _UDDEPFADM_SELECT_3HOURS;
			$arr[ '240' ] 		= _UDDEPFADM_SELECT_4HOURS;
			$arr[ '360' ] 		= _UDDEPFADM_SELECT_6HOURS;
			$arr[ '720' ] 		= _UDDEPFADM_SELECT_12HOURS;
			$arr[ '1440' ] 		= _UDDEPFADM_SELECT_1DAY;
			uddePF::admSelect($this->config_updateperiod, 'config_'.$this->plugin.'_updateperiod', $arr, _UDDEPFADM_UPDATEPERIOD_HEAD, _UDDEPFADM_UPDATEPERIOD_EXP);
		}
		if ($mode & (UDDEPF_MODE_COL1|UDDEPF_MODE_COL2|UDDEPF_MODE_COL3) || $mode & UDDEPF_MODE_PAGES ) {
			echo '<tr><td colspan="3"><hr></td></tr>';
			echo '<tr><td colspan="3"><b>'._UDDEPFADM_1STFRAME.'</b></td></tr>';
		}
		if ($mode & (UDDEPF_MODE_COL1|UDDEPF_MODE_COL2|UDDEPF_MODE_COL3)) {
			$arr = Array();
			if ($mode & UDDEPF_MODE_COL1)
				$arr[ '0' ] 		= _UDDEPFADM_SELECT_COL1;
			if ($mode & UDDEPF_MODE_COL2)
				$arr[ '1' ] 		= _UDDEPFADM_SELECT_COL2;
			if ($mode & UDDEPF_MODE_COL3)
				$arr[ '2' ] 		= _UDDEPFADM_SELECT_COL3;
			uddePF::admSelect($this->config_col, 'config_'.$this->plugin.'_col', $arr, _UDDEPFADM_COL_HEAD, _UDDEPFADM_COL_EXP);
		}
		if ($mode & UDDEPF_MODE_PAGES) {
			echo '<tr>';
			echo '<td align="left" valign="top"><strong>'._UDDEPFADM_PAGE_HEAD.'</strong></td>';
			echo '<td align="left" valign="top"><fieldset style="padding-top: 0px; padding-bottom: 0px; margin-bottom: 0px; border-style: none;" id="jform_config_pages" class="radio">';
			$isPage = explode(",", $this->config_page);
			for ($i=1;$i<=6;$i++) {
				$cs = '';
				if (in_array($i,$isPage)) $cs = 'checked="checked" ';
				echo "<input type='checkbox' ".$cs."name='config_".$this->plugin."_page[]' value='".$i."' id='cb".$this->plugin.$i."' />";
				echo "<label style='min-width:8px;' for='cb".$this->plugin.$i."'>".$i."&nbsp;&nbsp;</label>";
			}
			echo '</fieldset></td>';
			echo '<td align="left" valign="top" width="50%">'._UDDEPFADM_PAGE_EXP.'</td>';
			echo '</tr>';
		}
		if ($mode & (UDDEPF_MODE_COL1|UDDEPF_MODE_COL2|UDDEPF_MODE_COL3) || $mode & UDDEPF_MODE_PAGES ) {
			echo '<tr><td colspan="3"><hr></td></tr>';
			echo '<tr><td colspan="3"><b>'._UDDEPFADM_2NDFRAME.'</b></td></tr>';
		}
		if ($mode & (UDDEPF_MODE_COL1|UDDEPF_MODE_COL2|UDDEPF_MODE_COL3)) {
			$arr = Array();
			if ($mode & UDDEPF_MODE_COL1)
				$arr[ '0' ] 		= _UDDEPFADM_SELECT_COL1;
			if ($mode & UDDEPF_MODE_COL2)
				$arr[ '1' ] 		= _UDDEPFADM_SELECT_COL2;
			if ($mode & UDDEPF_MODE_COL3)
				$arr[ '2' ] 		= _UDDEPFADM_SELECT_COL3;
			uddePF::admSelect($this->config_col_1, 'config_'.$this->plugin.'_col_1', $arr, _UDDEPFADM_COL_HEAD, _UDDEPFADM_COL_EXP);
		}
		if ($mode & UDDEPF_MODE_PAGES) {
			echo '<tr>';
			echo '<td align="left" valign="top"><strong>'._UDDEPFADM_PAGE_HEAD.'</strong></td>';
			echo '<td align="left" valign="top"><fieldset style="padding-top: 0px; padding-bottom: 0px; margin-bottom: 0px; border-style: none;" id="jform_config_pages" class="radio">';
			$isPage = explode(",", $this->config_page_1);
			for ($i=1;$i<=6;$i++) {
				$cs = '';
				if (in_array($i,$isPage)) $cs = 'checked="checked" ';
				echo "<input type='checkbox' ".$cs."name='config_".$this->plugin."_page_1[]' value='".$i."' id='cb".$this->plugin.$i."_1' />";
				echo "<label style='min-width:8px;' for='cb".$this->plugin.$i."_1'>".$i."&nbsp;&nbsp;</label>";
			}
			echo '</fieldset></td>';
			echo '<td align="left" valign="top" width="50%">'._UDDEPFADM_PAGE_EXP.'</td>';
			echo '</tr>';
		}
	}

	protected function saveConfigurationHelper($data) {
		$data[ "config_enable" ]		= $this->config_enable;
		$data[ "config_updateperiod" ]	= $this->config_updateperiod;
		$data[ "config_page" ]			= $this->config_page;
		$data[ "config_col" ]			= $this->config_col;
		$data[ "config_page_1" ]		= $this->config_page_1;
		$data[ "config_col_1" ]			= $this->config_col_1;

		$query  = "DELETE FROM ".$this->tableconfig." WHERE plugin = '".$this->plugin."'";
		mysql_query($query, $this->dbconn) or die('Error: '.mysql_error());
		foreach($data as $key=>$value) {
			$query = "INSERT INTO ".$this->tableconfig." ( plugin, varname, value ) 
						VALUES ( '". mysql_real_escape_string($this->plugin) ."', '". mysql_real_escape_string($key) ."', '".  mysql_real_escape_string($value) ."' )";
			mysql_query($query, $this->dbconn) or die('Error: '.mysql_error());
		}
	}

	protected function getConfigurationHelper() {
		$this->config_enable 				= (int)uddePF::getParameter( 'config_'.$this->plugin.'_enable', 0, 'post', 'int' );
		$this->config_updateperiod			= (int)uddePF::getParameter( 'config_'.$this->plugin.'_updateperiod', 0, 'post', 'int' );
		$temp								= 	   uddePF::getParameter( 'config_'.$this->plugin.'_page', null, 'post', 'array' );
		$this->config_page					= implode(",", $temp);
		$this->config_col					= (int)uddePF::getParameter( 'config_'.$this->plugin.'_col', 0, 'post', 'int' );
		$temp								= 	   uddePF::getParameter( 'config_'.$this->plugin.'_page_1', null, 'post', 'array' );
		$this->config_page_1				= implode(",", $temp);
		$this->config_col_1					= (int)uddePF::getParameter( 'config_'.$this->plugin.'_col_1', 0, 'post', 'int' );
	}

	protected function deleteTableContent() {
		mysql_query("START TRANSACTION", $this->dbconn);
		$query = "Delete from ".$this->tablestore;
		mysql_query($query, $this->dbconn) or die('Error: '.mysql_error());
	}

	protected function checkIfUpdateRequired() {
		$update_required = 0;
		$query = "SELECT value FROM ".$this->tableconfig." WHERE plugin = '".$this->plugin."_PERS' AND varname = 'lastupdate'";
		$result = mysql_query($query, $this->dbconn) or die('Error: '.mysql_error());
		if (mysql_num_rows($result)==0) {
			$lastupdate = 0;
			$query = "INSERT INTO `".$this->tableconfig."` (`plugin`, `varname`, `value`) VALUES ('".$this->plugin."_PERS', 'lastupdate', '0')";
			mysql_query($query, $this->dbconn) or die('Error: '.mysql_error());
			$lastupdate = 0;
		} else {
			$lastupdate = (int)mysql_result($result,0);
		}
		$periodsecs = 0;
		if (isset($this->config_updateperiod))
			$periodsecs = ($this->config_updateperiod * 60) - 15;		// we subtract 15 seconds, so we do not miss an event, e.g. the cron job updates every 5 minutes and the plugin has also a 5 minute period
		if ($periodsecs < 0)
			$periodsecs = 0;
// echo "...Lastupdate: ".$lastupdate." Secs: ".$periodsecs." Left: ".($lastupdate + $periodsecs - time())." Required: ".$update_required."<br />";
		if ( time() >= $lastupdate + $periodsecs )
			$update_required = 1;
		return $update_required;
	}

	protected function updateDone() {
// echo "...Update counter refreshed<br />";
		$query = "UPDATE ".$this->tableconfig." SET `value` = '".time()."' WHERE plugin = '".$this->plugin."_PERS' AND varname = 'lastupdate'";
		$result = mysql_query($query, $this->dbconn) or die('Error: '.mysql_error());
	}
}
