<?php
// ********************************************************************************************
// Title          udde Picture Frame Information System (uddePF)
// Description    Picture Frame Information System for Joomla 1.5 and Joomla 1.6
// Author          2011 Stephan Slabihoud
// License        This is free software and you may redistribute it under the GPL.
//                uddePF comes with absolutely no warranty.
//                Use at your own risk. For details, see the license at
//                http://www.gnu.org/licenses/gpl.txt
//                Other licenses can be found in LICENSES folder.
//                Redistributing this file is only allowed when keeping the header unchanged.
//
// It uses parts of
//
// InfoFrame (image generator for digital picture frames)
// Copyright (C) 2009  Tobias Kolb
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// ********************************************************************************************

if (!(defined('_JEXEC') || defined('_VALID_MOS'))) { die( 'Direct Access to this location is not allowed.' ); }

class PFBenzinPlugin extends PFPlugin
{
	protected $config_benzin_ort = "Bottrop";
	protected $config_max_benzin = 5;
	protected $config_max_age = 12;
	protected $config_sorte = "Normal";

	public function __construct($dbconn, $tableprefix) {
        parent::__construct($dbconn, $tableprefix); 
		$this->_createTableIfNotExists();
	}

	public function getPluginName() {
		return _UDDEPFADM_BENZIN_PLUGIN;
	}
	
	public function getPluginVersion() {
		return "1.2";
	}

	public function showConfiguration() {
        parent::showConfigurationHelper(UDDEPF_MODE_COL1|UDDEPF_MODE_COL2|UDDEPF_MODE_COL3|UDDEPF_MODE_ENABLE|UDDEPF_MODE_UPDATE|UDDEPF_MODE_PAGES); 
		uddePF::admText($this->config_benzin_ort, 40, 'config_benzin_ort', _UDDEPFADM_BENZINORT_HEAD, _UDDEPFADM_BENZINORT_EXP, "", true);
		uddePF::admText($this->config_max_benzin, 5, 'config_max_benzin', _UDDEPFADM_BENZINMAX_HEAD, _UDDEPFADM_BENZINMAX_EXP);
		uddePF::admText($this->config_max_age, 12, 'config_max_age', _UDDEPFADM_BENZINAGE_HEAD, _UDDEPFADM_BENZINAGE_EXP);
		$arr = Array();
		$arr[  'Normal' ]						= _UDDEPFADM_BENZIN_NORMAL;
		$arr[  'Super' ]						= _UDDEPFADM_BENZIN_SUPERE10;
		$arr[  'SuperE5' ]						= _UDDEPFADM_BENZIN_SUPERE5;
		$arr[  'SuperPlus' ]					= _UDDEPFADM_BENZIN_SUPERPLUS;
		$arr[  'Diesel' ]						= _UDDEPFADM_BENZIN_DIESEL;
		$arr[  'VPower' ]						= _UDDEPFADM_BENZIN_VPOWER;
		$arr[  'Biodiesel' ]					= _UDDEPFADM_BENZIN_BIODIESEL;
		$arr[  'LKW-Diesel' ]					= _UDDEPFADM_BENZIN_LKWDIESEL;
		$arr[  'Autogas' ]						= _UDDEPFADM_BENZIN_AUTOGAS;
		$arr[  'Erdgas' ]						= _UDDEPFADM_BENZIN_ERDGAS;
		$arr[  'Pflanzenoel' ]					= _UDDEPFADM_BENZIN_PFLANZENOEL;
		$arr[  'Bioethanol' ]					= _UDDEPFADM_BENZIN_BIOETHANOL;
		uddePF::admSelect($this->config_sorte, 'config_sorte', $arr, _UDDEPFADM_BENZINSORTE_HEAD, _UDDEPFADM_BENZINSORTE_EXP);
	}

	public function getConfiguration() {
        parent::getConfigurationHelper(); 
		$this->config_benzin_ort		= 	   uddePF::getParameter( 'config_benzin_ort', "", 'post', 'string' );
		$this->config_max_benzin		= (int)uddePF::getParameter( 'config_max_benzin', 5, 'post', 'int' );
		$this->config_max_age			= (int)uddePF::getParameter( 'config_max_age', 12, 'post', 'int' );
		$this->config_sorte				=      uddePF::getParameter( 'config_sorte', "Normal", 'post', 'string' );
	}

	public function saveConfiguration() {
		$data = Array();
		$data["config_benzin_ort"]			= $this->config_benzin_ort;
		$data["config_max_benzin"]			= $this->config_max_benzin;
		$data["config_max_age"]				= $this->config_max_age;
		$data["config_sorte"]				= $this->config_sorte;
		parent::saveConfigurationHelper($data);
	}

	public function doUpdate($forceUpdate) {
		if (!$this->config_enable)
			return;

		if (!$forceUpdate) {
			if (!$this->checkIfUpdateRequired())		// check if update period is exceeded
				return;
		}

		$this->updateDone();

		$this->deleteTableContent();

		if ($this->config_benzin_ort) {
			$ort = $this->config_benzin_ort;
			$uri  = '/liste_payed.asp?'.'ort='.$ort.'&typ='.$this->config_sorte;
			$sock = fsockopen("www.clever-tanken.de", 80, $errno, $errstr, 5);
			if (!$sock) {
				return;
			} else {
				fputs($sock, "GET ".$uri." HTTP/1.1\r\n");
				fputs($sock, "Host: www.clever-tanken.de\r\n");
				fputs($sock, "Connection: close\r\n\r\n");
				$i = 0;
				while(!feof($sock)) {
					$zeile[$i++] = utf8_encode(trim(fgets($sock,1024)));
				}
				fclose($sock);
            }
        }

        // file zeilenweise einlesen und gefiltert entsprechend den Eintrgen in config.ini.
        $ortnumber = 0;
        for ($j=0;$j<$i;$j++) {
			if ($this->config_benzin_ort) {
				$ort = $this->config_benzin_ort;
				if ((stripos($zeile[$j],$ort))>0) {
					$tankstelle = strip_tags(trim($zeile[$j]),'<br>');
					$tankstelle = str_replace('<br>','|',$tankstelle);
					$adresse = explode('|',$tankstelle);
					$merken = 10;
				}
            }

            if ((strpos($zeile[$j],'Euro')>0) or (strpos($zeile[$j],',')>0)) {
                if ($merken>=1) {
                    $preis = strip_tags(trim($zeile[$j]));
                    $preis = str_replace('Euro','',$preis);
                }
            } else {
                if (strpos($zeile[$j],':')>0) {
                    if ($merken>=1) {
                        $d_arr = date_parse(strip_tags(trim($zeile[$j])));
                        $datum = mktime($d_arr['hour'],$d_arr['minute'],$d_arr['second'],$d_arr['month'],$d_arr['day'],$d_arr['year']);
						$alter = $this->config_max_age;
                        if ($datum>=strtotime("-$alter hours")) {
							$this->_addStation($ort, $preis, $datum, substr($adresse[2],11).', '.$adresse[0].', '.$adresse[1]);
						}
					}
				}
			}
            if ($merken>0) 
				$merken--;
        }
        mysql_query("COMMIT", $this->dbconn);
	}

	public function doOutput(&$image, $style, $forceUpdate, &$yoffset) {
		if (!$this->config_enable)
			return;

		if ($forceUpdate)
			$this->doUpdate(true);

		$col = $style['display']==1 ? $this->config_col : $this->config_col_1;
		$xpos = $style['xpos'.$col];

        $query = "SELECT * FROM `".$this->tablestore."` ORDER BY `preis` ASC, `datum` DESC";
        $result = mysql_query($query, $this->dbconn);
        if (mysql_num_rows($result) == 0) return;
        
        $opt_header = array(
            'width' => imagesx($image)/2-30,
            'height' => $style['textsize_huge'],
            'line_height' => $style['textsize_huge'],
            'align' => ALIGN_LEFT
        );

        $opt_entry = array(
            'width' => imagesx($image)/2-30,
            'height' => $style['textsize_normal'],
            'line_height' => $style['textsize_normal'],
            'align' => ALIGN_LEFT,
            'word_wrap_hyphen' => '...',
            'aggressive_word_wrap' => false,
        );

        // print header
        $text = 'Spritpreis ('.$this->config_sorte.')';
        imagettftextboxopt($image, $style['textsize_huge'], 0, $xpos+30, $yoffset[$col], $style['textcolor'], $style['font'], $text, $opt_header);

		$imagefile = dirname(__FILE__).'/'.$this->plugin.'/'.'icons'.'/fuel.png';
		$icon = ImageCreateFromPNG($imagefile);
        ImageCopy($image, $icon, $xpos, $yoffset[$col]-2, 0, 0, imagesx($icon), imagesy($icon));
        ImageDestroy($icon);
        $yoffset[$col] += 20;
		$yoffset[$col] += 8;

        while ($row = mysql_fetch_assoc($result)) {
            $counter++;
            $rest = (mysql_num_rows($result) - $counter) + 1;
            $entrylimit = $this->config_max_benzin;
            if ( (($entrylimit) && ($counter > $entrylimit)) || (($yoffset[$col] >= (imagesy($image) - 36)) && ($rest > 1)) ) {
                $rest = (mysql_num_rows($result) - $counter) + 1;
				$text = sprintf( _UDDEPFADM_MORE_FUEL, $rest );
                $yoffset[$col] += 4;
                $yoffset[$col] += imagettftextboxopt($image, $style['textsize_large'], 0, $xpos+4, $yoffset[$col], $style['textcolor'], $style['fontb'], $text, $opt_header);
                break;
            }

            $text = $row['preis'].' EUR/l';
            $text = $text.'  '.strftime( "%d.%m.-%H:%M", strtotime($row['datum']));
            $text2 = $row['station'];

            // print appointment text and button
			if (0) {
            if (stripos($row['station'],'aral')>0)            $png = 'resources/icons/aral.png';    // Aral-Tankstelle
            elseif (stripos($row['station'],'agip')>0)        $png = 'resources/icons/agip.png';    // Agip-Tankstelle
            elseif (stripos($row['station'],'bft')>0)            $png = 'resources/icons/bft.png';    // BFT-Tankstelle
            elseif (stripos($row['station'],'esso')>0)        $png = 'resources/icons/esso.png';    // Esso-Tankstelle
            elseif (stripos($row['station'],'heinlein')>0)        $png = 'resources/icons/h.png';        // Heinlein-Tankstelle
            elseif (stripos($row['station'],'jet')>0)            $png = 'resources/icons/jet.png';    // Jet-Tankstelle
            elseif (stripos($row['station'],'omv')>0)            $png = 'resources/icons/omv.png';    // OMV-Tankstelle
            elseif (stripos($row['station'],'shell')>0)        $png = 'resources/icons/shell.png';    // Shell-Tankstelle
            else     $png = 'resources/icons/t.png';
			}
            //$wicon = ImageCreateFromPNG ( $png );
            //ImageCopy($image, $wicon, $xpos, $yoffset[$col], 0, 0, imagesx($wicon), imagesy($wicon));
            //ImageDestroy($wicon);

            $yoffset[$col] += imagettftextboxopt($image, $style['textsize_normal'], 0, $xpos+30, $yoffset[$col], $style['textcolor'], $style['font'], $text, $opt_entry);
            $yoffset[$col] += 2;
            $yoffset[$col] += imagettftextboxopt($image, $style['textsize_normal'], 0, $xpos+30, $yoffset[$col], $style['textcolor'], $style['font'], $text2, $opt_entry);
            $yoffset[$col] += 6;
        }
        $yoffset[$col] += 16;
        mysql_free_result($result);
	}

	private function _addStation($ort, $preis, $datum, $station) {
		$query = "INSERT INTO `".$this->tablestore."` (`ort`, `datum`, `preis`, `station`) 
				  VALUES ('".mysql_real_escape_string($ort)."', FROM_UNIXTIME(".$datum."), 
				  '".mysql_real_escape_string($preis)."',
				  '".mysql_real_escape_string($station)."'
				  )";
		mysql_query($query, $this->dbconn) or die('Error, insert query failed: '.mysql_error());
	}

	private function _deleteTableContent() {
		mysql_query("START TRANSACTION", $this->dbconn);
		$query = "Delete from ".$this->tablestore;
		mysql_query($query, $this->dbconn) or die('Error: '.mysql_error());
	}

	private function _createTableIfNotExists() {
		if (mysql_num_rows( mysql_query("SHOW TABLES LIKE '".$this->tablestore."'", $this->dbconn) ) != 1) {
			$query = "CREATE TABLE `".$this->tablestore."` (
						`id` int(11) NOT NULL auto_increment,
						`ort` varchar(32) NOT NULL,
						`preis` varchar(16) NOT NULL,
						`datum` datetime NOT NULL,
						`station` varchar(100) NOT NULL,
						PRIMARY KEY  (`id`)
					) ENGINE=MyISAM; ";
			mysql_query($query, $this->dbconn) or die('Error, insert query failed: '.mysql_error());
		}
	}
}
