<?php
// ********************************************************************************************
// Title          udde Picture Frame Information System (uddePF)
// Description    Picture Frame Information System for Joomla 1.5 and Joomla 1.6
// Author          2011 Stephan Slabihoud
// License        This is free software and you may redistribute it under the GPL.
//                uddePF comes with absolutely no warranty.
//                Use at your own risk. For details, see the license at
//                http://www.gnu.org/licenses/gpl.txt
//                Other licenses can be found in LICENSES folder.
//                Redistributing this file is only allowed when keeping the header unchanged.
// ********************************************************************************************

if (!(defined('_JEXEC') || defined('_VALID_MOS'))) { die( 'Direct Access to this location is not allowed.' ); }

class PFDateTimePlugin extends PFPlugin
{
	protected $config_timeformat = "%H:%M";
	protected $config_dateformat = "%A, %e. %B %Y";
	protected $config_weeknumber = 0;
	
	public function __construct($dbconn, $tableprefix) {
        parent::__construct($dbconn, $tableprefix); 
	}

	public function getPluginName() {
		return _UDDEPFADM_DATETIME_PLUGIN;
	}
	
	public function getPluginVersion() {
		return "1.1";
	}

	public function showConfiguration() {
        parent::showConfigurationHelper(UDDEPF_MODE_ENABLE|UDDEPF_MODE_PAGES); 
		$arr = Array();
		$arr[ '%H:%M' ] 		= '22:40';
		$arr[ '%I:%M %P' ] 		= '10:40 pm';
		uddePF::admSelect($this->config_timeformat, 'config_timeformat', $arr, _UDDEPFADM_TIMEFORMAT_HEAD, _UDDEPFADM_TIMEFORMAT_EXP, true);
		$arr = Array();
		$arr[ '%Y-%m-%d' ] 		= '2007-08-05';
		$arr[ '%m/%d/%y' ] 		= '08/05/07';
		$arr[ '%A, %d.%m.%Y' ] 	= 'Tuesday, 05.08.2007';
		$arr[ '%a, %d.%m.%Y' ] 	= 'Tue, 05.08.2007';
		$arr[ '%e. %b' ] 		= '5. Aug (Linux)';
		$arr[ '%e. %B' ] 		= '5. August (Linux)';
		$arr[ '%e. %B %Y' ] 	= '5. August 2007 (Linux)';
		$arr[ '%a, %e. %b' ] 	= 'Tue, 5. Aug (Linux)';
		$arr[ '%a, %e. %b %Y' ]	= 'Tue, 5. Aug 2007 (Linux)';
		$arr[ '%A, %e. %B' ] 	= 'Tuesday, 5. August (Linux)';
		$arr[ '%A, %e. %B %Y' ]	= 'Tuesday, 5. August 2007 (Linux)';
		$arr[ '%#d. %b' ] 		= '5. Aug (Windows)';
		$arr[ '%#d. %B' ] 		= '5. August (Windows)';
		$arr[ '%#d. %B %Y' ] 	= '5. August 2007 (Windows)';
		$arr[ '%a, %#d. %b' ] 	= 'Tue, 5. Aug (Windows)';
		$arr[ '%a, %#d. %b %Y' ]	= 'Tue, 5. Aug (Windows)';
		$arr[ '%A, %#d. %B' ] 	= 'Tuesday, 5. August (Windows)';
		$arr[ '%A, %#d. %B %Y' ]	= 'Tuesday, 5. August 2007 (Windows)';
		uddePF::admSelect($this->config_dateformat, 'config_dateformat', $arr, _UDDEPFADM_DATEFORMAT_HEAD, _UDDEPFADM_DATEFORMAT_EXP);
		$arr = Array();
		$arr[ '0' ] 		= _UDDEPFADM_DATETIME_NO;
		$arr[ '1' ] 		= _UDDEPFADM_DATETIME_YESPREFIXED;
		$arr[ '2' ] 		= _UDDEPFADM_DATETIME_YESSUFFIXED;
		uddePF::admSelect($this->config_weeknumber, 'config_weeknumber', $arr, _UDDEPFADM_WEEKNUMBER_HEAD, _UDDEPFADM_WEEKNUMBER_EXP);
	}

	public function getConfiguration() {
        parent::getConfigurationHelper(); 
		$this->config_timeformat			= uddePF::getParameter( 'config_timeformat', '%H:%M', 'post', 'string' );
		$this->config_dateformat			= uddePF::getParameter( 'config_dateformat', '%A, %e. %B %Y', 'post', 'string' );
		$this->config_weeknumber			= (int)uddePF::getParameter( 'config_weeknumber', 0, 'post', 'int' );
	}

	public function saveConfiguration() {
		$data = Array(
						"config_timeformat"	=> $this->config_timeformat,
						"config_dateformat"	=> $this->config_dateformat,
						"config_weeknumber"	=> $this->config_weeknumber
					 );
		parent::saveConfigurationHelper($data);
	}

	public function doOutput(&$image, $style, $forceUpdate, &$yoffset) {
		if (!$this->config_enable)
			return;

		$arr = explode(",", $style['locale']);
		$loc = setlocale(LC_ALL, $arr);

		$opt = array(
			'width' => 450,
			'align' => ALIGN_LEFT
		);
		imagettftextboxopt($image, 72, 0, 20, 25, $style['textcolor'], $style['font'], strftime($this->config_timeformat), $opt);
		$df = $this->config_dateformat;
		if ($this->config_weeknumber==1)
			$df = "(".(int)date("W")." KW) ".$df;
		if ($this->config_weeknumber==2)
			$df = $df. " (".(int)date("W")._UDDEPFADM_DATETIME_KW.")";
		imagettftextboxopt($image, 24, 0, 20, 100, $style['textcolor'], $style['font'], strftime($df), $opt);
		imagesetthickness($image, 2);
		
		$imagew = imagesx($image);
		
		imageline($image, 15, 140, $imagew-20, 140, $style['textcolor']);
	}
}
