<?php
// ********************************************************************************************
// Title          udde Picture Frame Information System (uddePF)
// Description    Picture Frame Information System for Joomla 1.5 and Joomla 1.6
// Author          2011 Stephan Slabihoud
// License        This is free software and you may redistribute it under the GPL.
//                uddePF comes with absolutely no warranty.
//                Use at your own risk. For details, see the license at
//                http://www.gnu.org/licenses/gpl.txt
//                Other licenses can be found in LICENSES folder.
//                Redistributing this file is only allowed when keeping the header unchanged.
// ********************************************************************************************

if (!(defined('_JEXEC') || defined('_VALID_MOS'))) { die( 'Direct Access to this location is not allowed.' ); }

class PFSlideshowPlugin extends PFPlugin
{
	protected $config_slideshow_full = 1;
	
	public function __construct($dbconn, $tableprefix) {
        parent::__construct($dbconn, $tableprefix); 
		if (!file_exists( dirname(__FILE__).'/../cache/') )
			mkdir( dirname(__FILE__).'/../cache' );
	}

	public function getPluginName() {
		return _UDDEPFADM_SLIDESHOW_PLUGIN;
	}
	
	public function getPluginVersion() {
		return "1.1";
	}

	public function showConfiguration() {
        parent::showConfigurationHelper(UDDEPF_MODE_ENABLE|UDDEPF_MODE_UPDATE|UDDEPF_MODE_PAGES); 
		uddePF::admYesNo($this->config_slideshow_full, 'config_slideshow_full', _UDDEPFADM_SSF_HEAD, _UDDEPFADM_SSF_EXP, true);
	}

	public function getConfiguration() {
        parent::getConfigurationHelper(); 
		$this->config_slideshow_full	= (int)uddePF::getParameter( 'config_slideshow_full', 1, 'post', 'int' );
	}

	public function saveConfiguration() {
		$data = Array(
						"config_slideshow_full"	=> $this->config_slideshow_full
					 );
		parent::saveConfigurationHelper($data);
	}

	public function doUpdate($forceUpdate) {
		if (!$this->config_enable)
			return;

		if (!$forceUpdate) {
			if (!$this->checkIfUpdateRequired())		// check if update period is exceeded
				return;
		}

		$this->updateDone();

		$localpath = dirname(__FILE__).'/'.$this->plugin.'/'.'images'.'/'.'*.jpg';
		$thedir = glob( $localpath );

		$filename = dirname(__FILE__).'/../cache/slideshow.txt';
		$file = fopen($filename, 'w');
		if ($file) {
			fwrite($file, serialize($thedir));
			fclose($file);
		} else {
			if (file_exists($filename))
				unlink($filename);
		}
	}

	public function doOutput(&$image, $style, $forceUpdate, &$yoffset) {
		if (!$this->config_enable)
			return;

		$update_required = false;
		$filename = dirname(__FILE__).'/../cache/slideshow.txt';
		if (!file_exists($filename))
			$update_required = true;

		if ($forceUpdate || $update_required)
			$this->doUpdate(true);

		$temp = file_get_contents($filename);
		if ($temp) {
			$thedir = unserialize($temp); 
		} else {
			$thedir = Array();
		}
		if (!count($thedir))
			return;

		$index = mt_rand(0, count($thedir)-1);

		$bt = 5;
		$bb = 5;
		$bl = 5;
		$br = 5;
		$ypos = 141;
		$xpos = 20;

		$bgimagefile = $thedir[$index];
		if (!file_exists($bgimagefile)) {
			$this->doUpdate(true);
			return;	// try next round
		}

		$backgroundcol = ImageColorAllocate($image, 0, 0, 0);

		$bg = ImageCreateFromJpeg($bgimagefile);

		$ratio = imagesx($bg)/imagesy($bg);
		$h = imagesy($image)-$ypos-($bt+$bb);
		$w = $h*$ratio;
		
		$center = (imagesx($image)-$w)/2;

		// picture frame
		//imagefilledrectangle($image ,$xpos, $ypos, $xpos+$w+$bl+$br, imagesy($image)+$bt+$bb-1, $backgroundcol);
		//imagecopyresampled($image, $bg, $xpos+$bl+$center, $ypos+$bt, 0, 0, $w, $h, imagesx($bg), imagesy($bg));

		if ($this->config_slideshow_full)	// whole area
			imagefilledrectangle($image ,0, $ypos, imagesx($image)-1, imagesy($image)-1, $backgroundcol);
		else								// only picture + border
			imagefilledrectangle($image ,$center-$bl, $ypos, $center+$w+$br, imagesy($image)+$bt+$bb-1, $backgroundcol);

		imagecopyresampled($image, $bg, $center, $ypos+$bt, 0, 0, $w, $h, imagesx($bg), imagesy($bg));
		ImageDestroy($bg);
	}
}
