<?php
// ********************************************************************************************
// Title          udde Picture Frame Information System (uddePF)
// Description    Picture Frame Information System for Joomla 1.5 and Joomla 1.6
// Author          2011 Stephan Slabihoud
// License        This is free software and you may redistribute it under the GPL.
//                uddePF comes with absolutely no warranty.
//                Use at your own risk. For details, see the license at
//                http://www.gnu.org/licenses/gpl.txt
//                Other licenses can be found in LICENSES folder.
//                Redistributing this file is only allowed when keeping the header unchanged.
// ********************************************************************************************

if (!(defined('_JEXEC') || defined('_VALID_MOS'))) { die( 'Direct Access to this location is not allowed.' ); }

class PFStylePlugin extends PFPlugin
{
	protected $config_background = "none";
	protected $config_background_morning = "none";
	protected $config_background_evening = "none";
	protected $config_background_night = "none";
	
	public function __construct($dbconn, $tableprefix) {
        parent::__construct($dbconn, $tableprefix); 
	}

	public function getPluginName() {
		return _UDDEPFADM_STYLE_PLUGIN;
	}
	
	public function getPluginVersion() {
		return "1.1";
	}

	public function showConfiguration() {
        parent::showConfigurationHelper(UDDEPF_MODE_ENABLE|UDDEPF_MODE_PAGES); 
		$localpath = dirname(__FILE__).'/'.$this->plugin.'/'.'backgrounds'.'/'.'*.jpg';
		$thedir = glob( $localpath );
		$arr = Array();
		$arr['none'] = _UDDEPFADM_SELECT_NONE;
		$i = 0;
		foreach( $thedir as $key=>$value ) {
			$path_parts = pathinfo($value);
			$arr[ $path_parts['filename'] ] = $path_parts['filename'];
		}

		uddePF::admSelect($this->config_background, 'config_background', $arr, _UDDEPFADM_BACKGROUND_HEAD, _UDDEPFADM_BACKGROUND_EXP, true);
		uddePF::admSelect($this->config_background_morning, 'config_background_morning', $arr, _UDDEPFADM_BACKGROUNDM_HEAD, _UDDEPFADM_BACKGROUNDM_EXP);
		uddePF::admSelect($this->config_background_evening, 'config_background_evening', $arr, _UDDEPFADM_BACKGROUNDE_HEAD, _UDDEPFADM_BACKGROUNDE_EXP);
		uddePF::admSelect($this->config_background_night, 'config_background_night', $arr, _UDDEPFADM_BACKGROUNDN_HEAD, _UDDEPFADM_BACKGROUNDN_EXP);
	}

	public function getConfiguration() {
        parent::getConfigurationHelper(); 
		$this->config_background			= uddePF::getParameter( 'config_background', 'none', 'post', 'string' );
		$this->config_background_morning	= uddePF::getParameter( 'config_background_morning', 'none', 'post', 'string' );
		$this->config_background_evening	= uddePF::getParameter( 'config_background_evening', 'none', 'post', 'string' );
		$this->config_background_night		= uddePF::getParameter( 'config_background_night', 'none', 'post', 'string' );
	}

	public function saveConfiguration() {
		$data = Array(
						"config_background"			=> $this->config_background,
						"config_background_morning"	=> $this->config_background_morning,
						"config_background_evening"	=> $this->config_background_evening,
						"config_background_night"	=> $this->config_background_night
					 );
		parent::saveConfigurationHelper($data);
	}

	public function doPreflight(&$image, $style, $forceUpdate, &$yoffset) {
		if (!$this->config_enable)
			return;

		if ($this->config_background=="none") {
			$backgroundcol = ImageColorAllocate($image, 0, 0, 0);
			ImageFillToBorder($image, 0, 0, $backgroundcol, $backgroundcol);
			return;
		}

		$arr = explode(",", $style['locale']);
		$loc = setlocale(LC_ALL, $arr);

		$morning = mktime(6, 0, 0);
		$day = mktime(12, 0, 0);
		$evening = mktime(18, 0, 0);
		$night = mktime(22, 0, 0);
		$now = time();

		$bgimagefile = dirname(__FILE__).'/'.$this->plugin.'/'.'backgrounds'.'/'.$this->config_background.'.jpg';
		if ($this->config_background_morning != "none" && $now>=$morning && $now<$day) {
			$bgimagefile = dirname(__FILE__).'/'.$this->plugin.'/'.'backgrounds'.'/'.$this->config_background_morning.'.jpg';
		}
		if ($this->config_background_evening != "none" && $now>=$evening && $now<$night) {
			$bgimagefile = dirname(__FILE__).'/'.$this->plugin.'/'.'backgrounds'.'/'.$this->config_background_evening.'.jpg';
		}
		if ($this->config_background_night != "none" && ($now>=$night || $now<$morning)) {
			$bgimagefile = dirname(__FILE__).'/'.$this->plugin.'/'.'backgrounds'.'/'.$this->config_background_night.'.jpg';
		}

		// copy (resized) background image on background
		$bg = @ImageCreateFromJpeg($bgimagefile);
		if ($bg) {
			imagecopyresampled($image, $bg, 0, 0, 0, 0, imagesx($image), imagesy($image), imagesx($bg), imagesy($bg));
		}
	}
}
