<?php
// ********************************************************************************************
// Title          udde Picture Frame Information System (uddePF)
// Description    Picture Frame Information System for Joomla 1.5 and Joomla 1.6
// Author          2011 Stephan Slabihoud
// License        This is free software and you may redistribute it under the GPL.
//                uddePF comes with absolutely no warranty.
//                Use at your own risk. For details, see the license at
//                http://www.gnu.org/licenses/gpl.txt
//                Other licenses can be found in LICENSES folder.
//                Redistributing this file is only allowed when keeping the header unchanged.
// ********************************************************************************************

if (!(defined('_JEXEC') || defined('_VALID_MOS'))) { die( 'Direct Access to this location is not allowed.' ); }

class PFDWDPlugin extends PFPlugin
{
	//protected $config_slideshow_full = 1;
	
	public function __construct($dbconn, $tableprefix) {
        parent::__construct($dbconn, $tableprefix); 
		if (!file_exists( dirname(__FILE__).'/../cache/') )
			mkdir( dirname(__FILE__).'/../cache' );
	}

	public function getPluginName() {
		return _UDDEPFADM_DWD_PLUGIN;
	}
	
	public function getPluginVersion() {
		return "1.1";
	}

	public function showConfiguration() {
        parent::showConfigurationHelper(UDDEPF_MODE_ENABLE|UDDEPF_MODE_UPDATE|UDDEPF_MODE_PAGES); 
		//uddePF::admYesNo($this->config_slideshow_full, 'config_slideshow_full', _UDDEPFADM_SSF_HEAD, _UDDEPFADM_SSF_EXP, true);
	}

	public function getConfiguration() {
        parent::getConfigurationHelper(); 
		//$this->config_slideshow_full	= (int)uddePF::getParameter( 'config_slideshow_full', 1, 'post', 'int' );
	}

	public function saveConfiguration() {
		$data = Array(
		//				"config_slideshow_full"	=> $this->config_slideshow_full
					 );
		parent::saveConfigurationHelper($data);
	}

	public function doUpdate($forceUpdate) {
		if (!$this->config_enable)
			return;

		if (!$forceUpdate) {
			if (!$this->checkIfUpdateRequired())		// check if update period is exceeded
				return;
		}

		$this->updateDone();

		for ($i=1;$i<=2;$i++) {
		
			$url = $this->_getURL($i);
			$filename = $this->_getFilename($i);

			if ($url) {
				$curl = curl_init();
				$file = fopen($filename, 'w');
				if ($file) {
					curl_setopt($curl, CURLOPT_URL, utf8_encode($url));
					curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
					$im = $this->_curl_exec_follow($curl);
					curl_close($curl);
					fwrite($file, $im);
					fclose($file);
				}			
			} else {
				if (file_exists($filename))
					unlink($filename);
			}
		}
	}

	public function doOutput(&$image, $style, $forceUpdate, &$yoffset) {
		if (!$this->config_enable)
			return;

		$update_required = false;
		for ($i=1;$i<=2;$i++) {
			$filename = $this->_getFilename($i);
			if (!file_exists($filename))
			$update_required = true;
		}

		if ($forceUpdate || $update_required)
			$this->doUpdate(true);

			
			
		$ypos = 141;

		$backgroundcol = ImageColorAllocate($image, 0, 0, 0);
		imagefilledrectangle($image ,0, $ypos, imagesx($image)-1, imagesy($image)-1, $backgroundcol);

		//$bg1 = ImageCreateFromPNG($this->_getFilename(1));
		$bg1 = ImageCreateFromJpeg($this->_getFilename(1));
		$bg2 = ImageCreateFromJpeg($this->_getFilename(2));

		$ratio1 = imagesx($bg1)/imagesy($bg1);
		$h1 = imagesy($image)-$ypos-10;
		$w1 = $h1*$ratio1;
		
		$ratio2 = imagesx($bg2)/imagesy($bg2);
		$h2 = imagesy($image)-$ypos-10;
		$w2 = $h2*$ratio2;

		if ($w1+$w2+15>imagesx($image)) {
			$ww = ($w1+$w2+15)/imagesx($image);
			$w1 /= $ww;
			$h1 /= $ww;
			$w2 /= $ww;
			$h2 /= $ww;
		}

		$x = (imagesx($image)-$w1-$w2)/3;
		$y = (imagesy($image)-141-$h1-10)/2;

		$ypos += $y;

		$m = 0;
		if ($x>0)
			$m = $x;

		imagecopyresampled($image, $bg1, $x, $ypos+5, 0, 0, $w1, $h1, imagesx($bg1), imagesy($bg1));
		imagecopyresampled($image, $bg2, $x+$w1+$m, $ypos+5, 0, 0, $w2, $h2, imagesx($bg2), imagesy($bg2));
		ImageDestroy($bg1);
		ImageDestroy($bg2);
	}

	private function _curl_exec_follow(/*resource*/ $ch, /*int*/ &$maxredirect = null) {
		$mr = $maxredirect === null ? 5 : intval($maxredirect);
		$act_server = "";
		if (ini_get('open_basedir') == '' && ini_get('safe_mode' == 'Off')) {
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, $mr > 0);
			curl_setopt($ch, CURLOPT_MAXREDIRS, $mr);
		} else {
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, false);
			if ($mr > 0) {
				$newurl = curl_getinfo($ch, CURLINFO_EFFECTIVE_URL);
				$rch = curl_copy_handle($ch);
				curl_setopt($rch, CURLOPT_HEADER, true);
				curl_setopt($rch, CURLOPT_NOBODY, true);
				curl_setopt($rch, CURLOPT_FORBID_REUSE, false);
				curl_setopt($rch, CURLOPT_RETURNTRANSFER, true);
				do {
					$this->_getActServer($newurl, $act_server);
					curl_setopt($rch, CURLOPT_URL, $newurl);
					$header = curl_exec($rch);
					if (curl_errno($rch)) {
						$code = 0;
					} else {
						$code = curl_getinfo($rch, CURLINFO_HTTP_CODE);
						if ($code == 301 || $code == 302) {
							preg_match('/Location:(.*?)\n/', $header, $matches);
							$newurl = trim(array_pop($matches));
						} else {
							$code = 0;
						}
					}
				} while ($code && --$mr);
				curl_close($rch);
				if (!$mr) {
					if ($maxredirect === null) {
						echo 'Too many redirects. When following redirects, libcurl hit the maximum amount.';
					} else {
						$maxredirect = 0;
					}
					return false;
				}
				$this->_getActServer($newurl, $act_server);
				curl_setopt($ch, CURLOPT_URL, $newurl);
			}
		}
		return curl_exec($ch);
	} 

	private function _getActServer(&$newurl, &$actserver) {
		preg_match('@^(?:http://)?([^/]+)@i', $newurl, $arr);
		if ($arr[0])
			$actserver = $arr[0];
		if (!$arr[0]) {
			$newurl = $actserver.$newurl;
		}
	}
	
	private function _getFilename($i) {
		switch($i) {
			case 1:		$filename = dirname(__FILE__).'/../cache/dwd'.$i.'.jpg';	break;
			case 2:		$filename = dirname(__FILE__).'/../cache/dwd'.$i.'.jpg';	break;
			case 3:		$filename = dirname(__FILE__).'/../cache/dwd'.$i.'.jpg';	break;
			case 4:		$filename = dirname(__FILE__).'/../cache/dwd'.$i.'.jpg';	break;
			case 5:		$filename = dirname(__FILE__).'/../cache/dwd'.$i.'.png';	break;
		}
		return $filename;
	}
	
	private function _getURL($i) {
		switch($i) {
			case 1:		$url = 'http://www.dwd.de/wundk/radar/Webradar_Deutschland.jpg';			break;
			case 2:		$url = 'http://www.dwd.de/wundk/wetter/de/Deutschland.jpg';					break;
			case 3:		$url = 'http://www.dwd.de/wundk/wetter/de/Deutschland_morgen_frueh.jpg';	break;
			case 4:		$url = 'http://www.dwd.de/wundk/wetter/de/Deutschland_morgen_spaet.jpg';	break;
			case 5:		$url = 'http://www.dwd.de/wundk/sat/METE_STC_wwwCeur3km_aktuell_m00s.png';		break;
		}
		return $url;
	}
}
