<?php
// ********************************************************************************************
// Title          udde Picture Frame Information System (uddePF)
// Description    Picture Frame Information System for Joomla 1.5 and Joomla 1.6
// Author          2011 Stephan Slabihoud
// License        This is free software and you may redistribute it under the GPL.
//                uddePF comes with absolutely no warranty.
//                Use at your own risk. For details, see the license at
//                http://www.gnu.org/licenses/gpl.txt
//                Other licenses can be found in LICENSES folder.
//                Redistributing this file is only allowed when keeping the header unchanged.
// ********************************************************************************************

$debug=0;

$call_from_joomla = 0;
if (defined('_JEXEC') || defined('_VALID_MOS')) {
	$call_from_joomla = 1;
}

// *********************************************************************************************

if ($debug) echo "Loading Librarys...<br />";
require_once(dirname(__FILE__).'/../library/tools.php');
require_once(dirname(__FILE__).'/../library/pfplugin.php');
require_once(dirname(__FILE__).'/../library/imagettftextboxopt.php');

// *********************************************************************************************

if (!$call_from_joomla) {
	define('_JEXEC', 1);
	require_once(dirname(__FILE__).'/../../../../configuration.php');
	$josconfig = new JConfig();
	
	$config_db_host 		= $josconfig->host;
	$config_db_name 		= $josconfig->db;
	$config_db_user		 	= $josconfig->user;
	$config_db_password 	= $josconfig->password;
	$config_db_prefix 		= $josconfig->dbprefix;
	$config_site = "http://".$_SERVER["SERVER_NAME"];
	if ($debug) echo "Server name: ".$config_site."<br />";

	// *********************************************************************************************

	if ($debug) echo "Calling Standalone...<br />";
	if ($debug) echo "Open database...<br />";
	$connection = mysql_connect($config_db_host, $config_db_user, $config_db_password, true) or die('Error: ' . mysql_error());
	mysql_select_db($config_db_name, $connection) or die('Error: ' . mysql_error());
	if ($debug) echo "Create config object...<br />";
	$config = new uddePFconfig();
	
	// *********************************************************************************************
	
	if ($debug) echo "Load configuration...<br />";
	$query = "SELECT varname, value FROM ".$config_db_prefix."uddepf_config"." WHERE plugin = 'PFSystem'";
	$result = mysql_query($query, $connection) or die('Error: '.mysql_error());
    while ($row = mysql_fetch_object( $result )) {
		if (substr($row->varname,0,1)!='_')
			$config->{$row->varname} = stripslashes($row->value);		// unescape strings
    }

	uddePFtools::loadLanguage( "", $config->config_language );
	
	$debug = $config->config_debug;

	// *********************************************************************************************
	
	if ($debug) echo "Loading Plugins...<br />";
	$plugindir = glob( dirname(__FILE__).'/../plugins/'.'*.php' );
	$plugins = Array();
	$i = 0;
	foreach( $plugindir as $key=>$value ) {
		$path_parts = pathinfo($value);
		$plugins[$i]["filename"] = $path_parts['filename'];
		$plugins[$i]["file"] = $value;
		if ($debug) echo "...".$value."<br />";
		require_once $plugins[$i]["file"];
		$plugins[$i]["plugin"] = new $plugins[$i]["filename"]( $connection, $config_db_prefix );
		uddePFtools::loadLanguage( $plugins[$i]["filename"], $config->config_language );
		$i++;
	}



	// Reorder the plugins, so we draw everything in the correct order
	// Is there already an ordering?
	$temp = explode( ",", $config->config_plugins_ordering );
	// Rebuild the plugins array with the found ording, orphaned plugins will be ignored
	$ps = Array();
	$i = 0;
	foreach($temp as $key=>$pluginname) {
		foreach($plugins as $k=>$v) {
			if ($pluginname==$v["filename"]) {
				$ps[$i]["filename"] = $v["filename"];
				$ps[$i]["file"] 	= $v["file"];
				$ps[$i]["plugin"] 	= $v["plugin"];
				$i++;
			}
		}
	}
	// Check if there are new plugins and add them to the array
	foreach($plugins as $plugin=>$value) {
		$found = false;
		foreach($ps as $k=>$v) {
			if ($value["filename"]==$v["filename"]) {
				$found = true;
				break;
			}
		}
		if (!$found) {
			$ps[$i]["filename"] = $value["filename"];
			$ps[$i]["file"] 	= $value["file"];
			$ps[$i]["plugin"] 	= $value["plugin"];
			$i++;
		}
	}
	$plugins = $ps;
	// "ps" contains all plugins in the correct order




	$site = $config_site;

	$forceUpdate = false;

} else {
	// when called by Joomla, we already have a database connection, use this
	if ($debug) echo "Calling from Joomla...<br />";
	if ($debug) echo "Use Joomla database...<br />";
	$connection = uddePF::getConnection();
	if ($debug) echo "Use existing config object...<br />";
	if ($debug) echo "Plugins already loaded...<br />";
	$site = uddePF::uddePFgetPath('live_site');
	$config_db_prefix = uddePF::uddePFgetDBprefix();
}

// *********************************************************************************************
	
$current_page = uddePFtools::loadValue($connection, $config_db_prefix, "current_page", 0);
$current_page++;
if ($current_page>$config->config_maxpages)		// 0 and 1 are treated the same way, so it is not nice but working correct here
	$current_page = 1;
uddePFtools::updateValue($connection, $config_db_prefix, "current_page", $current_page);
if ($debug) echo "Preparing page #".$current_page."<br />";

// *********************************************************************************************

if ($debug) echo "Updating data...<br />";
if ($debug) echo "...forced update: ".($forceUpdate ? "yes" : "no")."<br />";

foreach( $plugins as $key=>$plugin ) {
	if ($debug) echo "...plugin: ".$plugin["plugin"]->getPluginName()."<br />";
	if ($debug) echo "...IsOnThisPage Frame1: ".($plugin["plugin"]->isOnThisPage($current_page) ? "yes" : "no")."<br />";

	// we do only need to update the plugin data, when it is displayed in this round
	$do_update = false;

	if ($plugin["plugin"]->isOnThisPage($current_page))
		$do_update = true;

	if ($config->config_enable2nd) {
		if ($debug) echo "...IsOnThisPage Frame2: ".($plugin["plugin"]->isOnThisPage2($current_page) ? "yes" : "no")."<br />";
		if ($plugin["plugin"]->isOnThisPage2($current_page))
			$do_update = true;
	}

	if ($do_update)
		$plugin["plugin"]->doUpdate($forceUpdate);
}

// *********************************************************************************************

$max = $config->config_enable2nd ? 2 : 1;
for($img=1;$img<=$max;$img++) {

	if ($debug) echo "Creating image for picture frame #".$img."...<br />";

	$image_width = $config->config_picture_width;
	$image_height = $config->config_picture_height;
	$xpos0 = $config->config_col0;
	$xpos1 = $config->config_col1;
	$xpos2 = $config->config_col2;
	if ($img==2) {
		$image_width = $config->config_picture_width_1;
		$image_height = $config->config_picture_height_1;
		$xpos0 = $config->config_col0_1;
		$xpos1 = $config->config_col1_1;
		$xpos2 = $config->config_col2_1;
	}

	$font  = dirname(__FILE__).'/../resources/fonts/'.$config->config_font.".ttf";
	$fontb = dirname(__FILE__).'/../resources/fonts/'.$config->config_fontb.".ttf";

	$im = ImageCreateTrueColor($image_width, $image_height);

	$style = array(); 
	$style['textcolor'] = ImageColorAllocate ($im, 255, 255, 255);
	$style['font'] = $font;
	$style['fontb'] = $fontb;
	$style['imagew'] = $image_width;
	$style['imageh'] = $image_height;
	$style['xpos0'] = $xpos0;
	$style['xpos1'] = $xpos1;
	$style['xpos2'] = $xpos2;
	$style['display'] = $img;
	$style['textsize_huge'] = 18;
	$style['textsize_large'] = 14;
	$style['textsize_normal'] = 12;
	$style['textsize_small'] = 10;
	if ($config->config_locale=="default")
		$style['locale'] = _UDDEPFADM_THIS_LOCALE;
	else
		$style['locale'] = $config->config_locale;

	if ($debug) echo "...picture size: ".$image_width."/".$image_height."<br />";
	if ($debug) echo "...using font (normal): ".$font."<br />";
	if ($debug) echo "...using font (bold): ".$fontb."<br />";

	if ($debug) echo "Starting preflight...<br />";
	$currentYOffset = Array();
	$currentYOffset[0] = 160;
	$currentYOffset[1] = 160;
	$currentYOffset[2] = 160;
	foreach( $plugins as $key=>$plugin ) {
		if ($img==1 && $plugin["plugin"]->isOnThisPage($current_page) ||
			$img==2 && $plugin["plugin"]->isOnThisPage2($current_page)) {
			if ($debug) echo "...plugin: ".$plugin["plugin"]->getPluginName()."<br />";
			$plugin["plugin"]->doPreflight($im, $style, false, $currentYOffset);
		}
	}
	if ($debug) echo "Starting output...<br />";
	$currentYOffset = Array();
	$currentYOffset[0] = 160;
	$currentYOffset[1] = 160;
	$currentYOffset[2] = 160;
	foreach( $plugins as $key=>$plugin ) {
		if ($img==1 && $plugin["plugin"]->isOnThisPage($current_page) ||
			$img==2 && $plugin["plugin"]->isOnThisPage2($current_page)) {
			if ($debug) echo "...plugin: ".$plugin["plugin"]->getPluginName()."<br />";
			$plugin["plugin"]->doOutput($im, $style, false, $currentYOffset);
		}
	}
	if ($debug) echo "Starting postflight...<br />";
	$currentYOffset = Array();
	$currentYOffset[0] = 160;
	$currentYOffset[1] = 160;
	$currentYOffset[2] = 160;
	foreach( $plugins as $key=>$plugin ) {
		if ($img==1 && $plugin["plugin"]->isOnThisPage($current_page) ||
			$img==2 && $plugin["plugin"]->isOnThisPage2($current_page)) {
			if ($debug) echo "...plugin: ".$plugin["plugin"]->getPluginName()."<br />";
			$plugin["plugin"]->doPostflight($im, $style, false, $currentYOffset);
		}
	}

	// *********************************************************************************************

	if ($debug) echo "Writing image...<br />";
	$ext = ($img==2) ? "2" : "";
	$file1 = dirname(__FILE__)."/../pictureframe/pf".$config->config_cryptedlink.$ext.".jpg";
	$file2 = dirname(__FILE__)."/../pictureframe/pf".$config->config_cryptedlink.$ext."copy.jpg";
	if ($debug) echo "...".$file1."<br />";
	if ($debug) echo "...".$file2."<br />";
	ImageJpeg($im, $file1, $config->config_quality);
	ImageJpeg($im, $file2, $config->config_quality);
	ImageDestroy($im); 

	// *********************************************************************************************

	if ($debug) echo "Updating RSS feed...<br />";

	$pfimage1 = $site.'/administrator/components/com_uddepf/pictureframe/'.'pf'.$config->config_cryptedlink.$ext.'.jpg';
	$pfimage2 = $site.'/administrator/components/com_uddepf/pictureframe/'.'pf'.$config->config_cryptedlink.$ext.'copy.jpg';
	if ($debug) echo "...".$pfimage1."<br />";
	if ($debug) echo "...".$pfimage2."<br />";

	$xmlrss20='<?xml version="1.0"?>
	<rss version="2.0"
			xmlns:media="http://search.yahoo.com/mrss/" >
		<channel>
			<title>uddePF</title>
			<ttl>1</ttl>
			<link>'.$site.'</link>
			<description>uddePF (Picture Frame Information System) Feed</description>
			<item>
				<title>uddePF picture</title>
				<link>'.$pfimage1.'</link>
				<guid>'.md5(uniqid(mt_rand(), true)).'</guid>
				<description>
	&lt;p&gt;&lt;a href=&quot;'. htmlentities($pfimage1). '&quot; title=&quot;Image1&quot;&gt;
	&lt;img src=&quot;'. htmlentities($pfimage1) .'&quot; width=&quot;'. $image_width/4 .'&quot; height=&quot;'. $image_height/4 .'&quot; alt=&quot;Image1&quot; /&gt;
	&lt;/a&gt;&lt;/p&gt;
				</description>
				<media:content url="'.$pfimage1.'" type="image/jpeg" height="'.$image_width.'" width="'.$image_height.'" />
			</item>
			<item>
				<title>uddePF picture</title>
				<link>'.$pfimage2.'</link>
				<guid>'.md5(uniqid(mt_rand(), true)).'</guid>
				<description>
	&lt;p&gt;&lt;a href=&quot;'. htmlentities($pfimage2). '&quot; title=&quot;Image2&quot;&gt;
	&lt;img src=&quot;'. htmlentities($pfimage2) .'&quot; width=&quot;'. $image_width/4 .'&quot; height=&quot;'. $image_height/4 .'&quot; alt=&quot;Image2&quot; /&gt;
	&lt;/a&gt;&lt;/p&gt;
				</description>
				<media:content url="'.$pfimage2.'" type="image/jpeg" height="'.$image_width.'" width="'.$image_height.'" />
			</item>
		</channel>
	</rss>';

	$rss = dirname(__FILE__)."/../pictureframe/pf".$config->config_cryptedlink.$ext.".xml";
	if ($debug) echo "...".$rss."<br />";
	$file = fopen($rss, "w");
	fwrite($file, $xmlrss20);
	fclose($file);

}

// *********************************************************************************************

if (!$call_from_joomla) {
	// when not called by Joomla, close the connection
	if ($debug) echo "Closing database...<br />";
	if (is_resource($connection)) {
		mysql_close($connection);
	}
}

// *********************************************************************************************

if ($debug) echo "Done...<br />";
