<?php
// ********************************************************************************************
// Title          udde Picture Frame Information System (uddePF)
// Description    Picture Frame Information System for Joomla 1.5 and Joomla 1.6
// Author          2011 Stephan Slabihoud
// License        This is free software and you may redistribute it under the GPL.
//                uddePF comes with absolutely no warranty.
//                Use at your own risk. For details, see the license at
//                http://www.gnu.org/licenses/gpl.txt
//                Other licenses can be found in LICENSES folder.
//                Redistributing this file is only allowed when keeping the header unchanged.
// ********************************************************************************************

if (!(defined('_JEXEC') || defined('_VALID_MOS'))) { die( 'Direct Access to this location is not allowed.' ); }

class uddePF {

	public function getConnection() {
		$dbo = JFactory::getDBO();
		$con = $dbo->getConnection();
		return $con;
	}

	public function admYesNo($value, $postvar, $head, $exp, $line=false ) {
		if ($line)
			echo '<tr><td colspan="3"><hr></td></tr>';
		echo '<tr align="center" valign="middle">';
		echo '<td align="left" valign="top"><strong>'.$head.'</strong></td>';
		echo '<td align="left" valign="top">';
		$arr = Array();
		$arr[] = uddePF::_option( '1', _UDDEPFADM_YES );
		$arr[] = uddePF::_option( '0', _UDDEPFADM_NO );
		echo '<fieldset style="padding-top:0px;padding-bottom:0px;margin-bottom:0px;border-style:none;" id="jform_'.$postvar.'" class="radio">';
		echo uddePF::_radiolist( $arr, $postvar, 'class="inputbox" size="2"', $value );
		echo '</fieldset>';
		echo '</td>';
		echo '<td align="left" valign="top" width="50%">'.$exp.'</td>';
		echo '</tr>';
	}

	public function admSelect($value, $postvar, $options_arr, $head, $exp, $line=false ) {
		if ($line)
			echo '<tr><td colspan="3"><hr></td></tr>';
		echo '<tr align="center" valign="middle">';
		echo '<td align="left" valign="top"><strong>'.$head.'</strong></td>';
		echo '<td align="left" valign="top">';
		$arr = Array();
		foreach ($options_arr as $key => $val)
			$arr[] = uddePF::_option( $key, $val );
		echo uddePF::_selectlist( $arr, $postvar, 'class="inputbox" size="1"', $value );
		echo '</td>';
		echo '<td align="left" valign="top" width="50%">'.$exp.'</td>';
		echo '</tr>';
	}

	public function admText($value, $size, $postvar, $head, $exp, $suffix='', $line=false ) {
		if ($line)
			echo '<tr><td colspan="3"><hr></td></tr>';
		echo '<tr align="center" valign="middle">';
		echo '<td align="left" valign="top"><strong>'.$head.'</strong></td>';
		echo '<td align="left" valign="top"><input type="text" name="'.$postvar.'" size="'.$size.'" value="'.uddePF::_clean($value).'" /> '.uddePF::_clean($suffix).'</td>';
		echo '<td align="left" valign="top" width="50%">'.$exp.'</td>';
		echo '</tr>';
	}

	public function getParameter( $name, $default=null, $hash='default', $type='none', $mask=0 ) {
		$var = null;
		if (class_exists("JRequest")) {
			return JRequest::getVar ($name, $default, $hash, $type, $mask);
		}
		switch(strtolower($hash)) {
			case "get":		$arr =& $_GET; break;
			case "post":	$arr =& $_POST; break;
			default:		$arr =& $_REQUEST; break;
		}
		if (isset ($arr[$name]))
			$var = $array[$name];
		if (is_null($var))
			$var = $default;
		if (is_string($var))
			$var = trim($var);
		$var = strip_tags($var);
		return $var;
	}

	// used in admSelect and admYesNo
	public function _option( $value, $text="", $disable=false ) {
		$obj = new stdClass;
		$obj->value		= $value;
		$obj->text		= trim($text) ? $text : $value;
		$obj->disable	= $disable;
		return $obj;
	}

	// used in admYesNo
	public function _radiolist( $arr, $postvar, $attribs="", $selected=null ) {
		reset( $arr );
		$html = '';
		for ($i=0, $n=count( $arr ); $i < $n; $i++ ) {
			$k	= $arr[$i]->value;
			$t	= $arr[$i]->text;
			$extra = ((string)$k == (string)$selected ? " checked=\"checked\"" : '');
			$html .= "\n\t<input type=\"radio\" name=\"$postvar\" id=\"$postvar$k\" value=\"".uddePF::_clean($k)."\"".$extra." ".$attribs." />";
			$html .= "\n\t<label for=\"$postvar$k\">".uddePF::_clean($t)."</label>";
		}
		$html .= "\n";
		return $html;
	}

	// used in admSelected
	public function _selectlist( $arr, $postvar, $attribs="", $selected=NULL ) {
		reset( $arr );
		$html	= '<select name="'. $postvar .'" id="'. $postvar .'" '. $attribs .'>';
		$html	.= uddePF::_options( $arr, $selected );
		$html	.= '</select>';
		return $html;
	}

	// used in _selectlist
	public function _options( $arr, $selected=null ) {
		$html = '';
		foreach ($arr as $i => $option) {
			$element =& $arr[$i]; // since current doesn't return a reference, need to do this
			$k 		= $element->value;
			$t	 	= $element->text;
			$extra	 = '';
			if (isset( $element->disable ) && $element->disable) {
				$extra .= ' disabled="disabled"';
			}
			$extra .= ( (string)$k == (string)$selected  ? ' selected="selected"' : '' );
			$html .= '<option value="'.uddePF::_clean($k).'" '.$extra.'>'.uddePF::_clean($t).'</option>';
		}
		return $html;
	}
	
	public function _clean($string) {
		return htmlentities($string, ENT_QUOTES, 'UTF-8');
	}

	function uddePFgetGID($myself) {
		$database =& JFactory::getDBO();
		$my_gid = Array(0);
		if ($myself) {
			$sql="SELECT g.id AS gid 
				FROM (#__users AS u INNER JOIN #__user_usergroup_map AS um ON u.id=um.user_id) 
				INNER JOIN #__usergroups AS g ON um.group_id=g.id WHERE u.id=".(int)$myself;
			$database->setQuery($sql);
			$rows = $database->loadObjectList();
			$my_gid = Array();					// 1 = Public, 2 = Registered, ...
			foreach($rows as $key => $value) {
				if ($value->gid<=1)
					$my_gid[] = (int)0;
				else
					$my_gid[] = (int)$value->gid;
			}
		}
		return $my_gid;
	}

	function uddePFisAdmin($my_gid) {
		$new = array_intersect($my_gid, array(7,8));
		return !empty($new);
	}

	function uddePFgetLang() {
		$lang =& JFactory::getLanguage();
		$tag = $lang->getTag();
		$tag1 = strtolower(substr($tag,0,2));
		$tag2 = strtolower(substr($tag,3,2));
		switch($tag1) {
			case "af":		$temp = "afrikaansi";		break;
			case "sq":		$temp = "albanian";			break;
			case "ar":		$temp = "arabic";			break;
			case "az":		$temp = "azeri";			break;
			case "bg":		$temp = "bulgarian";		break;
			case "bn":		$temp = "bengali";			break;
			case "bs":		$temp = "bosanski";			break;
			case "ca":		$temp = "catalan";			break;
			case "cs":		$temp = "czech";			break;
			case "da":		$temp = "danish";			break;
			case "de":		$temp = "german";			break;
			case "el":		$temp = "greek";			break;
			case "en":		$temp = "english";			break;
			case "eo":		$temp = "esperanto";		break;
			case "es":		$temp = "spanish";			break;
			case "eu":		$temp = "basque";			break;
			case "fa":		$temp = "farsi";			break;
			case "fi":		$temp = "finnish";			break;
			case "fr":		$temp = "french";			break;
			case "he":		$temp = "hebrew";			break;
			case "hi":		$temp = "hindi";			break;
			case "hr":		$temp = "hrvatski";			break;
			case "hu":		$temp = "hungarian";		break;
			case "hy":		$temp = "armenian";			break;
			case "it":		$temp = "italian";			break;
			case "ja":		$temp = "japanese";			break;
			case "ko":		$temp = "korean";			break;
			case "lo":		$temp = "lao";				break;
			case "lt":		$temp = "english";			break;
			case "lv":		$temp = "english";			break;
			case "nb":		$temp = "norwegian";		break;
			case "nl":		$temp = "dutch";			break;
			case "pl":		$temp = "polish";			break;
			case "pt":		if ($tag2=="br")
								$temp = "brazilian_portuguese";
							else
								$temp = "portuguese";	
							break;
			case "ro":		$temp = "romanian";			break;
			case "ru":		$temp = "russian";			break;
			case "sk":		$temp = "slovak";			break;
			case "sr":		if ($tag2=="me")
								$temp = "montenegrin";
							else
								$temp = "serbian";
							break;
			case "sv":		$temp = "swedish";			break;
			case "th":		$temp = "thai";				break;
			case "tr":		$temp = "turkish";			break;
			case "uk":		$temp = "ukrainian";		break;
			case "vi":		$temp = "vietnamese";		break;
			case "zh":		if ($tag2=="cn")
								$temp = "simplified_chinese";
							else
								$temp = "traditional_chinese";
							break;
			case "en":		$temp = "english";			break;
			default: 		$temp = "english";			break;
		}
		return $temp;
	}

	function uddePFgetUserID() {
		$user =& JFactory::getUser();
		return $user->id;
	}

	function uddePFgetDBprefix() {
		$dbo = JFactory::getDBO();
		return $dbo->getPrefix();
//		$cfg =& JFactory::getConfig();
//		return $cfg->getValue('config.dbprefix');  
	}

	function uddePFgetPath($path, $component="com_uddepf") {
		switch($path) {
			case "absolute_path":	return JPATH_SITE;
			case "live_site":		return substr_replace(JURI::root(), '', -1, 1);
			case "admin":			return JPATH_ADMINISTRATOR .'/components/'.$component;
			case "user":			return JPATH_SITE .'/components/'.$component;
		}
		return null;
	}
	
}
